#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 10
#define STATE_COUNT 158
#define SYMBOL_COUNT 82
#define ALIAS_COUNT 4
#define TOKEN_COUNT 51
#define EXTERNAL_TOKEN_COUNT 1
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 6

enum {
  sym_disjunction_delimiter = 1,
  aux_sym__invalid_quantifier_token1 = 2,
  aux_sym__invalid_quantifier_token2 = 3,
  aux_sym__invalid_quantifier_token3 = 4,
  aux_sym__invalid_secondary_quantifier_token1 = 5,
  anon_sym_LBRACE = 6,
  anon_sym_STAR = 7,
  anon_sym_QMARK = 8,
  anon_sym_PLUS = 9,
  aux_sym_count_quantifier_token1 = 10,
  anon_sym_COMMA = 11,
  anon_sym_RBRACE = 12,
  anon_sym_QMARK_EQ = 13,
  anon_sym_QMARK_BANG = 14,
  anon_sym_QMARK_LT_EQ = 15,
  anon_sym_QMARK_LT_BANG = 16,
  anon_sym_BSLASH = 17,
  aux_sym_backreference_token1 = 18,
  anon_sym_BSLASHk_LT = 19,
  anon_sym_GT = 20,
  anon_sym_QMARK_LT = 21,
  aux_sym_group_name_token1 = 22,
  aux_sym_group_name_token2 = 23,
  anon_sym_QMARK_COLON = 24,
  sym_group_begin = 25,
  sym_group_end = 26,
  anon_sym_LBRACK = 27,
  anon_sym_CARET = 28,
  anon_sym_DASH = 29,
  anon_sym_RBRACK = 30,
  aux_sym_set_atom_token1 = 31,
  anon_sym_BSLASHb = 32,
  aux_sym_set_octal_escape_token1 = 33,
  aux_sym_set_identity_escape_token1 = 34,
  sym_character_class_escape = 35,
  aux_sym_identity_escape_token1 = 36,
  anon_sym_BSLASH0 = 37,
  aux_sym_octal_escape_token1 = 38,
  anon_sym_u = 39,
  aux_sym_unicode_escape_token1 = 40,
  anon_sym_x = 41,
  aux_sym_hexadecimal_escape_token1 = 42,
  anon_sym_c = 43,
  aux_sym_control_letter_escape_token1 = 44,
  sym_special_escape = 45,
  sym_end_assertion = 46,
  sym_non_boundary_assertion = 47,
  sym_any_character = 48,
  sym_non_syntax_character = 49,
  sym_null_character = 50,
  sym_regex = 51,
  sym_disjunction = 52,
  sym_zero_or_more = 53,
  sym_one_or_more = 54,
  sym_optional = 55,
  sym_count_quantifier = 56,
  sym_lookahead_assertion = 57,
  sym_negative_lookahead_assertion = 58,
  sym_lookbehind_assertion = 59,
  sym_negative_lookbehind_assertion = 60,
  sym_backreference = 61,
  sym_named_capturing_group = 62,
  sym_named_capturing_group_identifier = 63,
  sym_group_name = 64,
  sym_non_capturing_group = 65,
  sym_anonymous_capturing_group = 66,
  sym_character_set = 67,
  sym_set_range = 68,
  sym_set_octal_escape = 69,
  sym_set_identity_escape = 70,
  sym_identity_escape = 71,
  sym_octal_escape = 72,
  sym_unicode_escape = 73,
  sym_hexadecimal_escape = 74,
  sym_control_letter_escape = 75,
  sym__escape_operator = 76,
  sym_start_assertion = 77,
  sym_boundary_assertion = 78,
  aux_sym_pattern_repeat1 = 79,
  aux_sym_group_name_repeat1 = 80,
  aux_sym_character_set_repeat1 = 81,
  alias_sym_escape_operator = 82,
  alias_sym_lazy = 83,
  alias_sym_range_delimiter = 84,
  alias_sym_set_negation = 85,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_disjunction_delimiter] = "disjunction_delimiter",
  [aux_sym__invalid_quantifier_token1] = "_invalid_quantifier_token1",
  [aux_sym__invalid_quantifier_token2] = "_invalid_quantifier_token2",
  [aux_sym__invalid_quantifier_token3] = "_invalid_quantifier_token3",
  [aux_sym__invalid_secondary_quantifier_token1] = "_invalid_secondary_quantifier_token1",
  [anon_sym_LBRACE] = "{",
  [anon_sym_STAR] = "*",
  [anon_sym_QMARK] = "?",
  [anon_sym_PLUS] = "+",
  [aux_sym_count_quantifier_token1] = "count_quantifier_value",
  [anon_sym_COMMA] = "count_quantifier_delimiter",
  [anon_sym_RBRACE] = "}",
  [anon_sym_QMARK_EQ] = "lookahead_identifier",
  [anon_sym_QMARK_BANG] = "negative_lookahead_identifier",
  [anon_sym_QMARK_LT_EQ] = "lookbehind_identifier",
  [anon_sym_QMARK_LT_BANG] = "negative_lookbehind_identifier",
  [anon_sym_BSLASH] = "\\",
  [aux_sym_backreference_token1] = "backreference_token1",
  [anon_sym_BSLASHk_LT] = "\\k<",
  [anon_sym_GT] = ">",
  [anon_sym_QMARK_LT] = "?<",
  [aux_sym_group_name_token1] = "group_name_token1",
  [aux_sym_group_name_token2] = "group_name_token2",
  [anon_sym_QMARK_COLON] = "non_capturing_group_identifier",
  [sym_group_begin] = "group_begin",
  [sym_group_end] = "group_end",
  [anon_sym_LBRACK] = "set_begin",
  [anon_sym_CARET] = "^",
  [anon_sym_DASH] = "-",
  [anon_sym_RBRACK] = "set_end",
  [aux_sym_set_atom_token1] = "non_syntax_character",
  [anon_sym_BSLASHb] = "\\b",
  [aux_sym_set_octal_escape_token1] = "octal_code",
  [aux_sym_set_identity_escape_token1] = "set_identity_escape_token1",
  [sym_character_class_escape] = "character_class_escape",
  [aux_sym_identity_escape_token1] = "identity_escape_token1",
  [anon_sym_BSLASH0] = "\\0",
  [aux_sym_octal_escape_token1] = "octal_code",
  [anon_sym_u] = "u",
  [aux_sym_unicode_escape_token1] = "unicode_code",
  [anon_sym_x] = "x",
  [aux_sym_hexadecimal_escape_token1] = "hexadecimal_code",
  [anon_sym_c] = "c",
  [aux_sym_control_letter_escape_token1] = "control_letter_code",
  [sym_special_escape] = "special_escape",
  [sym_end_assertion] = "end_assertion",
  [sym_non_boundary_assertion] = "non_boundary_assertion",
  [sym_any_character] = "any_character",
  [sym_non_syntax_character] = "non_syntax_character",
  [sym_null_character] = "null_character",
  [sym_regex] = "regex",
  [sym_disjunction] = "disjunction",
  [sym_zero_or_more] = "zero_or_more",
  [sym_one_or_more] = "one_or_more",
  [sym_optional] = "optional",
  [sym_count_quantifier] = "count_quantifier",
  [sym_lookahead_assertion] = "lookahead_assertion",
  [sym_negative_lookahead_assertion] = "negative_lookahead_assertion",
  [sym_lookbehind_assertion] = "lookbehind_assertion",
  [sym_negative_lookbehind_assertion] = "negative_lookbehind_assertion",
  [sym_backreference] = "backreference",
  [sym_named_capturing_group] = "named_capturing_group",
  [sym_named_capturing_group_identifier] = "named_capturing_group_identifier",
  [sym_group_name] = "group_name",
  [sym_non_capturing_group] = "non_capturing_group",
  [sym_anonymous_capturing_group] = "anonymous_capturing_group",
  [sym_character_set] = "character_class",
  [sym_set_range] = "character_range",
  [sym_set_octal_escape] = "octal_escape",
  [sym_set_identity_escape] = "identity_escape",
  [sym_identity_escape] = "identity_escape",
  [sym_octal_escape] = "octal_escape",
  [sym_unicode_escape] = "unicode_escape",
  [sym_hexadecimal_escape] = "hexadecimal_escape",
  [sym_control_letter_escape] = "control_letter_escape",
  [sym__escape_operator] = "_escape_operator",
  [sym_start_assertion] = "start_assertion",
  [sym_boundary_assertion] = "boundary_assertion",
  [aux_sym_pattern_repeat1] = "pattern_repeat1",
  [aux_sym_group_name_repeat1] = "group_name_repeat1",
  [aux_sym_character_set_repeat1] = "character_set_repeat1",
  [alias_sym_escape_operator] = "escape_operator",
  [alias_sym_lazy] = "lazy",
  [alias_sym_range_delimiter] = "range_delimiter",
  [alias_sym_set_negation] = "set_negation",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_disjunction_delimiter] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__invalid_quantifier_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__invalid_quantifier_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__invalid_quantifier_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__invalid_secondary_quantifier_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_count_quantifier_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_EQ] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_BANG] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_LT_EQ] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_LT_BANG] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_backreference_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BSLASHk_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_LT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_group_name_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_group_name_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_QMARK_COLON] = {
    .visible = true,
    .named = true,
  },
  [sym_group_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_group_end] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_set_atom_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHb] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_set_octal_escape_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_set_identity_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_character_class_escape] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_identity_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BSLASH0] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_octal_escape_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_unicode_escape_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_x] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_hexadecimal_escape_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_c] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_control_letter_escape_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_special_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_end_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_non_boundary_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_any_character] = {
    .visible = true,
    .named = true,
  },
  [sym_non_syntax_character] = {
    .visible = true,
    .named = true,
  },
  [sym_null_character] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_zero_or_more] = {
    .visible = true,
    .named = true,
  },
  [sym_one_or_more] = {
    .visible = true,
    .named = true,
  },
  [sym_optional] = {
    .visible = true,
    .named = true,
  },
  [sym_count_quantifier] = {
    .visible = true,
    .named = true,
  },
  [sym_lookahead_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_negative_lookahead_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_lookbehind_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_negative_lookbehind_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_backreference] = {
    .visible = true,
    .named = true,
  },
  [sym_named_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_named_capturing_group_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_group_name] = {
    .visible = true,
    .named = true,
  },
  [sym_non_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_character_set] = {
    .visible = true,
    .named = true,
  },
  [sym_set_range] = {
    .visible = true,
    .named = true,
  },
  [sym_set_octal_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_set_identity_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_identity_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_octal_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_unicode_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_hexadecimal_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_control_letter_escape] = {
    .visible = true,
    .named = true,
  },
  [sym__escape_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_start_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_boundary_assertion] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_group_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_character_set_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_escape_operator] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_lazy] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_range_delimiter] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_set_negation] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[17][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_special_escape,
  },
  [2] = {
    [0] = alias_sym_escape_operator,
  },
  [3] = {
    [0] = sym_non_syntax_character,
    [1] = sym_non_syntax_character,
  },
  [4] = {
    [1] = alias_sym_lazy,
  },
  [5] = {
    [1] = sym_non_syntax_character,
  },
  [6] = {
    [1] = alias_sym_set_negation,
  },
  [7] = {
    [0] = sym_special_escape,
    [1] = sym_non_syntax_character,
  },
  [8] = {
    [1] = alias_sym_range_delimiter,
  },
  [9] = {
    [1] = alias_sym_range_delimiter,
    [2] = sym_special_escape,
  },
  [10] = {
    [0] = sym_special_escape,
    [1] = alias_sym_range_delimiter,
  },
  [11] = {
    [0] = sym_special_escape,
    [1] = alias_sym_range_delimiter,
    [2] = sym_special_escape,
  },
  [12] = {
    [0] = alias_sym_escape_operator,
    [2] = sym_non_syntax_character,
  },
  [13] = {
    [0] = sym_non_syntax_character,
    [1] = sym_non_syntax_character,
    [2] = sym_non_syntax_character,
  },
  [14] = {
    [3] = alias_sym_lazy,
  },
  [15] = {
    [4] = alias_sym_lazy,
  },
  [16] = {
    [5] = alias_sym_lazy,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lookahead == 0;
  switch (state) {
    case 0:
      if (eof) ADVANCE(25);
      if (lookahead == '$') ADVANCE(75);
      if (lookahead == '(') ADVANCE(53);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '*') ADVANCE(33);
      if (lookahead == '+') ADVANCE(35);
      if (lookahead == ',') ADVANCE(37);
      if (lookahead == '-') ADVANCE(57);
      if (lookahead == '.') ADVANCE(77);
      if (lookahead == '0') ADVANCE(36);
      if (lookahead == '>') ADVANCE(48);
      if (lookahead == '?') ADVANCE(34);
      if (lookahead == '[') ADVANCE(55);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == ']') ADVANCE(58);
      if (lookahead == '^') ADVANCE(56);
      if (lookahead == '_') ADVANCE(50);
      if (lookahead == 'c') ADVANCE(72);
      if (lookahead == 'u') ADVANCE(68);
      if (lookahead == 'x') ADVANCE(70);
      if (lookahead == '{') ADVANCE(31);
      if (lookahead == '|') ADVANCE(26);
      if (lookahead == '}') ADVANCE(38);
      if (lookahead == '\n' ||
          lookahead == '/') ADVANCE(59);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(36);
      if (lookahead == 8204 ||
          lookahead == 8205) ADVANCE(51);
      if (('1' <= lookahead && lookahead <= '7')) ADVANCE(36);
      if (lookahead == 'D' ||
          lookahead == 'S' ||
          lookahead == 'W' ||
          ('b' <= lookahead && lookahead <= 'd') ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          ('r' <= lookahead && lookahead <= 'w')) ADVANCE(50);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(50);
      if (lookahead != 0) ADVANCE(59);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(40);
      if (lookahead == ':') ADVANCE(52);
      if (lookahead == '<') ADVANCE(49);
      if (lookahead == '=') ADVANCE(39);
      END_STATE();
    case 2:
      if (lookahead == ',') ADVANCE(37);
      if (lookahead == '>') ADVANCE(48);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == '}') ADVANCE(38);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 8204 ||
          lookahead == 8205) ADVANCE(51);
      END_STATE();
    case 3:
      if (lookahead == ',') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(28);
      END_STATE();
    case 4:
      if (lookahead == '-') ADVANCE(57);
      if (lookahead == '\\') ADVANCE(45);
      if (lookahead == ']') ADVANCE(58);
      if (lookahead != 0) ADVANCE(59);
      END_STATE();
    case 5:
      if (lookahead == '0') ADVANCE(13);
      if (('1' <= lookahead && lookahead <= '7')) ADVANCE(67);
      END_STATE();
    case 6:
      if (lookahead == '<') ADVANCE(47);
      END_STATE();
    case 7:
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(50);
      END_STATE();
    case 8:
      if (lookahead == '\\') ADVANCE(45);
      if (lookahead == ']') ADVANCE(58);
      if (lookahead == '^') ADVANCE(56);
      if (lookahead != 0) ADVANCE(59);
      END_STATE();
    case 9:
      if (lookahead == '\\') ADVANCE(45);
      if (lookahead == ']') ADVANCE(58);
      if (lookahead != 0) ADVANCE(59);
      END_STATE();
    case 10:
      if (lookahead == 'c') ADVANCE(72);
      if (lookahead == 'u') ADVANCE(68);
      if (lookahead == 'x') ADVANCE(70);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(62);
      if (('1' <= lookahead && lookahead <= '7')) ADVANCE(61);
      if (lookahead != 0 &&
          lookahead != '0' &&
          lookahead != 'D' &&
          lookahead != 'S' &&
          lookahead != 'W' &&
          (lookahead < 'b' || 'd' < lookahead) &&
          lookahead != 'f' &&
          lookahead != 'n' &&
          (lookahead < 'r' || 'w' < lookahead)) ADVANCE(64);
      END_STATE();
    case 11:
      if (lookahead == 'c') ADVANCE(72);
      if (lookahead == 'u') ADVANCE(68);
      if (lookahead == 'x') ADVANCE(70);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '0' &&
          lookahead != 'D' &&
          lookahead != 'S' &&
          lookahead != 'W' &&
          (lookahead < 'b' || 'd' < lookahead) &&
          lookahead != 'f' &&
          lookahead != 'n' &&
          (lookahead < 'r' || 'w' < lookahead)) ADVANCE(64);
      END_STATE();
    case 12:
      if (lookahead == '}') ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(73);
      END_STATE();
    case 13:
      if (('1' <= lookahead && lookahead <= '7')) ADVANCE(66);
      END_STATE();
    case 14:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(14);
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(29);
      END_STATE();
    case 15:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(71);
      END_STATE();
    case 16:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(69);
      END_STATE();
    case 17:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(15);
      END_STATE();
    case 18:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(16);
      END_STATE();
    case 19:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(18);
      END_STATE();
    case 20:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(19);
      END_STATE();
    case 21:
      if (eof) ADVANCE(25);
      if (lookahead == '$') ADVANCE(75);
      if (lookahead == '(') ADVANCE(53);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '*') ADVANCE(33);
      if (lookahead == '+') ADVANCE(35);
      if (lookahead == '.') ADVANCE(77);
      if (lookahead == '?') ADVANCE(34);
      if (lookahead == '[') ADVANCE(55);
      if (lookahead == '\\') ADVANCE(44);
      if (lookahead == '^') ADVANCE(56);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead == '|') ADVANCE(26);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/' &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(78);
      END_STATE();
    case 22:
      if (eof) ADVANCE(25);
      if (lookahead == '$') ADVANCE(75);
      if (lookahead == '(') ADVANCE(53);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '.') ADVANCE(77);
      if (lookahead == '?') ADVANCE(34);
      if (lookahead == '[') ADVANCE(55);
      if (lookahead == '\\') ADVANCE(44);
      if (lookahead == '^') ADVANCE(56);
      if (lookahead == '{') ADVANCE(31);
      if (lookahead == '|') ADVANCE(26);
      if (lookahead == '*' ||
          lookahead == '+') ADVANCE(30);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/' &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(78);
      END_STATE();
    case 23:
      if (eof) ADVANCE(25);
      if (lookahead == '$') ADVANCE(75);
      if (lookahead == '(') ADVANCE(53);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '.') ADVANCE(77);
      if (lookahead == '?') ADVANCE(1);
      if (lookahead == '[') ADVANCE(55);
      if (lookahead == '\\') ADVANCE(44);
      if (lookahead == '^') ADVANCE(56);
      if (lookahead == '|') ADVANCE(26);
      if (lookahead == '}') ADVANCE(38);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '/' &&
          lookahead != ']' &&
          lookahead != '{') ADVANCE(78);
      END_STATE();
    case 24:
      if (eof) ADVANCE(25);
      if (lookahead == '$') ADVANCE(75);
      if (lookahead == '(') ADVANCE(53);
      if (lookahead == ')') ADVANCE(54);
      if (lookahead == '.') ADVANCE(77);
      if (lookahead == '[') ADVANCE(55);
      if (lookahead == '\\') ADVANCE(44);
      if (lookahead == '^') ADVANCE(56);
      if (lookahead == '{') ADVANCE(31);
      if (lookahead == '|') ADVANCE(26);
      if (lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '?') ADVANCE(30);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/' &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(78);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(sym_disjunction_delimiter);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(aux_sym__invalid_quantifier_token1);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(aux_sym__invalid_quantifier_token2);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(aux_sym__invalid_quantifier_token3);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(aux_sym__invalid_secondary_quantifier_token1);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3);
      if (lookahead != 0) ADVANCE(27);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(aux_sym_count_quantifier_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(36);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_QMARK_EQ);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_QMARK_BANG);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_QMARK_LT_EQ);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_QMARK_LT_BANG);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      if (lookahead == '0') ADVANCE(65);
      if (lookahead == 'B') ADVANCE(76);
      if (lookahead == 'b') ADVANCE(60);
      if (lookahead == 'k') ADVANCE(6);
      if (lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          lookahead == 't' ||
          lookahead == 'v') ADVANCE(74);
      if (lookahead == 'D' ||
          lookahead == 'S' ||
          lookahead == 'W' ||
          lookahead == 'd' ||
          lookahead == 's' ||
          lookahead == 'w') ADVANCE(63);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      if (lookahead == '0') ADVANCE(65);
      if (lookahead == 'b') ADVANCE(60);
      if (lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          lookahead == 't' ||
          lookahead == 'v') ADVANCE(74);
      if (lookahead == 'D' ||
          lookahead == 'S' ||
          lookahead == 'W' ||
          lookahead == 'd' ||
          lookahead == 's' ||
          lookahead == 'w') ADVANCE(63);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(aux_sym_backreference_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(46);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_BSLASHk_LT);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_QMARK_LT);
      if (lookahead == '!') ADVANCE(42);
      if (lookahead == '=') ADVANCE(41);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(aux_sym_group_name_token1);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(aux_sym_group_name_token2);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_QMARK_COLON);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_group_begin);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_group_end);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(aux_sym_set_atom_token1);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_BSLASHb);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(aux_sym_set_octal_escape_token1);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(aux_sym_set_identity_escape_token1);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_character_class_escape);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(aux_sym_identity_escape_token1);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_BSLASH0);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(aux_sym_octal_escape_token1);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(aux_sym_octal_escape_token1);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(66);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_u);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_x);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(aux_sym_hexadecimal_escape_token1);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_c);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(aux_sym_control_letter_escape_token1);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_special_escape);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_end_assertion);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_non_boundary_assertion);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_any_character);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_non_syntax_character);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 23, .external_lex_state = 1},
  [2] = {.lex_state = 23, .external_lex_state = 1},
  [3] = {.lex_state = 23, .external_lex_state = 1},
  [4] = {.lex_state = 23, .external_lex_state = 1},
  [5] = {.lex_state = 23, .external_lex_state = 1},
  [6] = {.lex_state = 23, .external_lex_state = 1},
  [7] = {.lex_state = 23, .external_lex_state = 1},
  [8] = {.lex_state = 23, .external_lex_state = 1},
  [9] = {.lex_state = 23, .external_lex_state = 1},
  [10] = {.lex_state = 23, .external_lex_state = 1},
  [11] = {.lex_state = 23, .external_lex_state = 1},
  [12] = {.lex_state = 23, .external_lex_state = 1},
  [13] = {.lex_state = 23, .external_lex_state = 1},
  [14] = {.lex_state = 23, .external_lex_state = 1},
  [15] = {.lex_state = 23, .external_lex_state = 1},
  [16] = {.lex_state = 23, .external_lex_state = 1},
  [17] = {.lex_state = 23, .external_lex_state = 1},
  [18] = {.lex_state = 23, .external_lex_state = 1},
  [19] = {.lex_state = 23, .external_lex_state = 1},
  [20] = {.lex_state = 21, .external_lex_state = 1},
  [21] = {.lex_state = 21, .external_lex_state = 1},
  [22] = {.lex_state = 21, .external_lex_state = 1},
  [23] = {.lex_state = 21, .external_lex_state = 1},
  [24] = {.lex_state = 21, .external_lex_state = 1},
  [25] = {.lex_state = 21, .external_lex_state = 1},
  [26] = {.lex_state = 21, .external_lex_state = 1},
  [27] = {.lex_state = 21, .external_lex_state = 1},
  [28] = {.lex_state = 21, .external_lex_state = 1},
  [29] = {.lex_state = 21, .external_lex_state = 1},
  [30] = {.lex_state = 21, .external_lex_state = 1},
  [31] = {.lex_state = 21, .external_lex_state = 1},
  [32] = {.lex_state = 21, .external_lex_state = 1},
  [33] = {.lex_state = 21, .external_lex_state = 1},
  [34] = {.lex_state = 21, .external_lex_state = 1},
  [35] = {.lex_state = 21, .external_lex_state = 1},
  [36] = {.lex_state = 21, .external_lex_state = 1},
  [37] = {.lex_state = 21, .external_lex_state = 1},
  [38] = {.lex_state = 21, .external_lex_state = 1},
  [39] = {.lex_state = 21, .external_lex_state = 1},
  [40] = {.lex_state = 21, .external_lex_state = 1},
  [41] = {.lex_state = 21, .external_lex_state = 1},
  [42] = {.lex_state = 21, .external_lex_state = 1},
  [43] = {.lex_state = 21, .external_lex_state = 1},
  [44] = {.lex_state = 21, .external_lex_state = 1},
  [45] = {.lex_state = 21, .external_lex_state = 1},
  [46] = {.lex_state = 21, .external_lex_state = 1},
  [47] = {.lex_state = 21, .external_lex_state = 1},
  [48] = {.lex_state = 21, .external_lex_state = 1},
  [49] = {.lex_state = 21, .external_lex_state = 1},
  [50] = {.lex_state = 21, .external_lex_state = 1},
  [51] = {.lex_state = 21, .external_lex_state = 1},
  [52] = {.lex_state = 21, .external_lex_state = 1},
  [53] = {.lex_state = 21, .external_lex_state = 1},
  [54] = {.lex_state = 21, .external_lex_state = 1},
  [55] = {.lex_state = 21, .external_lex_state = 1},
  [56] = {.lex_state = 21, .external_lex_state = 1},
  [57] = {.lex_state = 21, .external_lex_state = 1},
  [58] = {.lex_state = 22, .external_lex_state = 1},
  [59] = {.lex_state = 22, .external_lex_state = 1},
  [60] = {.lex_state = 22, .external_lex_state = 1},
  [61] = {.lex_state = 22, .external_lex_state = 1},
  [62] = {.lex_state = 22, .external_lex_state = 1},
  [63] = {.lex_state = 22, .external_lex_state = 1},
  [64] = {.lex_state = 24, .external_lex_state = 1},
  [65] = {.lex_state = 24, .external_lex_state = 1},
  [66] = {.lex_state = 24, .external_lex_state = 1},
  [67] = {.lex_state = 24, .external_lex_state = 1},
  [68] = {.lex_state = 8, .external_lex_state = 1},
  [69] = {.lex_state = 24, .external_lex_state = 1},
  [70] = {.lex_state = 24, .external_lex_state = 1},
  [71] = {.lex_state = 24, .external_lex_state = 1},
  [72] = {.lex_state = 24, .external_lex_state = 1},
  [73] = {.lex_state = 24, .external_lex_state = 1},
  [74] = {.lex_state = 9, .external_lex_state = 1},
  [75] = {.lex_state = 9, .external_lex_state = 1},
  [76] = {.lex_state = 9, .external_lex_state = 1},
  [77] = {.lex_state = 9, .external_lex_state = 1},
  [78] = {.lex_state = 23, .external_lex_state = 1},
  [79] = {.lex_state = 23, .external_lex_state = 1},
  [80] = {.lex_state = 23, .external_lex_state = 1},
  [81] = {.lex_state = 23, .external_lex_state = 1},
  [82] = {.lex_state = 23, .external_lex_state = 1},
  [83] = {.lex_state = 23, .external_lex_state = 1},
  [84] = {.lex_state = 9, .external_lex_state = 1},
  [85] = {.lex_state = 9, .external_lex_state = 1},
  [86] = {.lex_state = 23, .external_lex_state = 1},
  [87] = {.lex_state = 4, .external_lex_state = 1},
  [88] = {.lex_state = 4, .external_lex_state = 1},
  [89] = {.lex_state = 4, .external_lex_state = 1},
  [90] = {.lex_state = 4, .external_lex_state = 1},
  [91] = {.lex_state = 4, .external_lex_state = 1},
  [92] = {.lex_state = 4, .external_lex_state = 1},
  [93] = {.lex_state = 4, .external_lex_state = 1},
  [94] = {.lex_state = 4, .external_lex_state = 1},
  [95] = {.lex_state = 4, .external_lex_state = 1},
  [96] = {.lex_state = 4, .external_lex_state = 1},
  [97] = {.lex_state = 4, .external_lex_state = 1},
  [98] = {.lex_state = 4, .external_lex_state = 1},
  [99] = {.lex_state = 4, .external_lex_state = 1},
  [100] = {.lex_state = 9, .external_lex_state = 1},
  [101] = {.lex_state = 9, .external_lex_state = 1},
  [102] = {.lex_state = 9, .external_lex_state = 1},
  [103] = {.lex_state = 9, .external_lex_state = 1},
  [104] = {.lex_state = 9, .external_lex_state = 1},
  [105] = {.lex_state = 9, .external_lex_state = 1},
  [106] = {.lex_state = 9, .external_lex_state = 1},
  [107] = {.lex_state = 9, .external_lex_state = 1},
  [108] = {.lex_state = 9, .external_lex_state = 1},
  [109] = {.lex_state = 9, .external_lex_state = 1},
  [110] = {.lex_state = 9, .external_lex_state = 1},
  [111] = {.lex_state = 9, .external_lex_state = 1},
  [112] = {.lex_state = 9, .external_lex_state = 1},
  [113] = {.lex_state = 9, .external_lex_state = 1},
  [114] = {.lex_state = 9, .external_lex_state = 1},
  [115] = {.lex_state = 9, .external_lex_state = 1},
  [116] = {.lex_state = 10},
  [117] = {.lex_state = 10},
  [118] = {.lex_state = 10},
  [119] = {.lex_state = 11},
  [120] = {.lex_state = 2},
  [121] = {.lex_state = 2},
  [122] = {.lex_state = 2},
  [123] = {.lex_state = 10},
  [124] = {.lex_state = 7},
  [125] = {.lex_state = 7},
  [126] = {.lex_state = 2},
  [127] = {.lex_state = 10},
  [128] = {.lex_state = 23},
  [129] = {.lex_state = 12},
  [130] = {.lex_state = 2},
  [131] = {.lex_state = 17},
  [132] = {.lex_state = 23},
  [133] = {.lex_state = 0},
  [134] = {.lex_state = 5},
  [135] = {.lex_state = 23},
  [136] = {.lex_state = 23},
  [137] = {.lex_state = 23},
  [138] = {.lex_state = 23},
  [139] = {.lex_state = 23},
  [140] = {.lex_state = 0},
  [141] = {.lex_state = 23},
  [142] = {.lex_state = 20},
  [143] = {.lex_state = 23},
  [144] = {.lex_state = 12},
  [145] = {.lex_state = 12},
  [146] = {.lex_state = 10},
  [147] = {.lex_state = 2},
  [148] = {.lex_state = 2},
  [149] = {.lex_state = 5},
  [150] = {.lex_state = 20},
  [151] = {.lex_state = 17},
  [152] = {.lex_state = 12},
  [153] = {.lex_state = 5},
  [154] = {.lex_state = 20},
  [155] = {.lex_state = 17},
  [156] = {.lex_state = 12},
  [157] = {.lex_state = 20},
};

enum {
  ts_external_token_null_character = 0,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_null_character] = sym_null_character,
};

static bool ts_external_scanner_states[2][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_null_character] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_disjunction_delimiter] = ACTIONS(1),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [aux_sym_count_quantifier_token1] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [aux_sym_backreference_token1] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [aux_sym_group_name_token1] = ACTIONS(1),
    [aux_sym_group_name_token2] = ACTIONS(1),
    [sym_group_begin] = ACTIONS(1),
    [sym_group_end] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [aux_sym_set_atom_token1] = ACTIONS(1),
    [aux_sym_set_octal_escape_token1] = ACTIONS(1),
    [aux_sym_set_identity_escape_token1] = ACTIONS(1),
    [aux_sym_identity_escape_token1] = ACTIONS(1),
    [anon_sym_u] = ACTIONS(1),
    [anon_sym_x] = ACTIONS(1),
    [anon_sym_c] = ACTIONS(1),
    [aux_sym_control_letter_escape_token1] = ACTIONS(1),
    [sym_end_assertion] = ACTIONS(1),
    [sym_any_character] = ACTIONS(1),
    [sym_non_syntax_character] = ACTIONS(1),
    [sym_null_character] = ACTIONS(1),
  },
  [1] = {
    [sym_regex] = STATE(133),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(23),
    [sym_unicode_escape] = STATE(23),
    [sym_hexadecimal_escape] = STATE(23),
    [sym_control_letter_escape] = STATE(23),
    [sym__escape_operator] = STATE(123),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(11),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [sym_special_escape] = ACTIONS(19),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym_non_syntax_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(19),
  },
  [2] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_named_capturing_group_identifier] = STATE(14),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(23),
    [sym_unicode_escape] = STATE(23),
    [sym_hexadecimal_escape] = STATE(23),
    [sym_control_letter_escape] = STATE(23),
    [sym__escape_operator] = STATE(123),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(12),
    [anon_sym_QMARK_EQ] = ACTIONS(21),
    [anon_sym_QMARK_BANG] = ACTIONS(23),
    [anon_sym_QMARK_LT_EQ] = ACTIONS(25),
    [anon_sym_QMARK_LT_BANG] = ACTIONS(27),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [anon_sym_QMARK_LT] = ACTIONS(29),
    [anon_sym_QMARK_COLON] = ACTIONS(31),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(33),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [sym_special_escape] = ACTIONS(19),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym_non_syntax_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(19),
  },
  [3] = {
    [sym_disjunction] = STATE(128),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(23),
    [sym_unicode_escape] = STATE(23),
    [sym_hexadecimal_escape] = STATE(23),
    [sym_control_letter_escape] = STATE(23),
    [sym__escape_operator] = STATE(123),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(4),
    [ts_builtin_sym_end] = ACTIONS(35),
    [sym_disjunction_delimiter] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [sym_special_escape] = ACTIONS(19),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym_non_syntax_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(19),
  },
  [4] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(23),
    [sym_unicode_escape] = STATE(23),
    [sym_hexadecimal_escape] = STATE(23),
    [sym_control_letter_escape] = STATE(23),
    [sym__escape_operator] = STATE(123),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(4),
    [ts_builtin_sym_end] = ACTIONS(39),
    [sym_disjunction_delimiter] = ACTIONS(39),
    [anon_sym_BSLASH] = ACTIONS(41),
    [anon_sym_BSLASHk_LT] = ACTIONS(44),
    [sym_group_begin] = ACTIONS(47),
    [sym_group_end] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(50),
    [anon_sym_CARET] = ACTIONS(53),
    [anon_sym_BSLASHb] = ACTIONS(56),
    [sym_character_class_escape] = ACTIONS(59),
    [anon_sym_BSLASH0] = ACTIONS(62),
    [sym_special_escape] = ACTIONS(65),
    [sym_end_assertion] = ACTIONS(59),
    [sym_non_boundary_assertion] = ACTIONS(59),
    [sym_any_character] = ACTIONS(59),
    [sym_non_syntax_character] = ACTIONS(59),
    [sym_null_character] = ACTIONS(65),
  },
  [5] = {
    [sym_disjunction] = STATE(135),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(23),
    [sym_unicode_escape] = STATE(23),
    [sym_hexadecimal_escape] = STATE(23),
    [sym_control_letter_escape] = STATE(23),
    [sym__escape_operator] = STATE(123),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(4),
    [sym_disjunction_delimiter] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(68),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [sym_special_escape] = ACTIONS(19),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym_non_syntax_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(19),
  },
  [6] = {
    [sym_disjunction] = STATE(136),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(23),
    [sym_unicode_escape] = STATE(23),
    [sym_hexadecimal_escape] = STATE(23),
    [sym_control_letter_escape] = STATE(23),
    [sym__escape_operator] = STATE(123),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(4),
    [sym_disjunction_delimiter] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [sym_special_escape] = ACTIONS(19),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym_non_syntax_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(19),
  },
  [7] = {
    [sym_disjunction] = STATE(137),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(23),
    [sym_unicode_escape] = STATE(23),
    [sym_hexadecimal_escape] = STATE(23),
    [sym_control_letter_escape] = STATE(23),
    [sym__escape_operator] = STATE(123),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(4),
    [sym_disjunction_delimiter] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(72),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [sym_special_escape] = ACTIONS(19),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym_non_syntax_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(19),
  },
  [8] = {
    [sym_disjunction] = STATE(139),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(23),
    [sym_unicode_escape] = STATE(23),
    [sym_hexadecimal_escape] = STATE(23),
    [sym_control_letter_escape] = STATE(23),
    [sym__escape_operator] = STATE(123),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(4),
    [sym_disjunction_delimiter] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(74),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [sym_special_escape] = ACTIONS(19),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym_non_syntax_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(19),
  },
  [9] = {
    [sym_disjunction] = STATE(141),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(23),
    [sym_unicode_escape] = STATE(23),
    [sym_hexadecimal_escape] = STATE(23),
    [sym_control_letter_escape] = STATE(23),
    [sym__escape_operator] = STATE(123),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(4),
    [sym_disjunction_delimiter] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(76),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [sym_special_escape] = ACTIONS(19),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym_non_syntax_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(19),
  },
  [10] = {
    [sym_disjunction] = STATE(143),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(23),
    [sym_unicode_escape] = STATE(23),
    [sym_hexadecimal_escape] = STATE(23),
    [sym_control_letter_escape] = STATE(23),
    [sym__escape_operator] = STATE(123),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(4),
    [sym_disjunction_delimiter] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(78),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [sym_special_escape] = ACTIONS(19),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym_non_syntax_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(19),
  },
  [11] = {
    [sym_disjunction] = STATE(140),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(23),
    [sym_unicode_escape] = STATE(23),
    [sym_hexadecimal_escape] = STATE(23),
    [sym_control_letter_escape] = STATE(23),
    [sym__escape_operator] = STATE(123),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(4),
    [ts_builtin_sym_end] = ACTIONS(80),
    [sym_disjunction_delimiter] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [sym_special_escape] = ACTIONS(19),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym_non_syntax_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(19),
  },
  [12] = {
    [sym_disjunction] = STATE(132),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(23),
    [sym_unicode_escape] = STATE(23),
    [sym_hexadecimal_escape] = STATE(23),
    [sym_control_letter_escape] = STATE(23),
    [sym__escape_operator] = STATE(123),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(4),
    [sym_disjunction_delimiter] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(82),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [sym_special_escape] = ACTIONS(19),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym_non_syntax_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(19),
  },
  [13] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(23),
    [sym_unicode_escape] = STATE(23),
    [sym_hexadecimal_escape] = STATE(23),
    [sym_control_letter_escape] = STATE(23),
    [sym__escape_operator] = STATE(123),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(3),
    [ts_builtin_sym_end] = ACTIONS(84),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(84),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [sym_special_escape] = ACTIONS(19),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym_non_syntax_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(19),
  },
  [14] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(23),
    [sym_unicode_escape] = STATE(23),
    [sym_hexadecimal_escape] = STATE(23),
    [sym_control_letter_escape] = STATE(23),
    [sym__escape_operator] = STATE(123),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(5),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(86),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [sym_special_escape] = ACTIONS(19),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym_non_syntax_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(19),
  },
  [15] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(23),
    [sym_unicode_escape] = STATE(23),
    [sym_hexadecimal_escape] = STATE(23),
    [sym_control_letter_escape] = STATE(23),
    [sym__escape_operator] = STATE(123),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(6),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(88),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [sym_special_escape] = ACTIONS(19),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym_non_syntax_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(19),
  },
  [16] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(23),
    [sym_unicode_escape] = STATE(23),
    [sym_hexadecimal_escape] = STATE(23),
    [sym_control_letter_escape] = STATE(23),
    [sym__escape_operator] = STATE(123),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(10),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(90),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [sym_special_escape] = ACTIONS(19),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym_non_syntax_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(19),
  },
  [17] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(23),
    [sym_unicode_escape] = STATE(23),
    [sym_hexadecimal_escape] = STATE(23),
    [sym_control_letter_escape] = STATE(23),
    [sym__escape_operator] = STATE(123),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(9),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(92),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [sym_special_escape] = ACTIONS(19),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym_non_syntax_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(19),
  },
  [18] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(23),
    [sym_unicode_escape] = STATE(23),
    [sym_hexadecimal_escape] = STATE(23),
    [sym_control_letter_escape] = STATE(23),
    [sym__escape_operator] = STATE(123),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(8),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(94),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [sym_special_escape] = ACTIONS(19),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym_non_syntax_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(19),
  },
  [19] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(23),
    [sym_unicode_escape] = STATE(23),
    [sym_hexadecimal_escape] = STATE(23),
    [sym_control_letter_escape] = STATE(23),
    [sym__escape_operator] = STATE(123),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(7),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(96),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [sym_special_escape] = ACTIONS(19),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym_non_syntax_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(19),
  },
  [20] = {
    [sym_zero_or_more] = STATE(71),
    [sym_one_or_more] = STATE(71),
    [sym_optional] = STATE(71),
    [sym_count_quantifier] = STATE(71),
    [ts_builtin_sym_end] = ACTIONS(98),
    [sym_disjunction_delimiter] = ACTIONS(98),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(100),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(100),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(100),
    [anon_sym_LBRACE] = ACTIONS(102),
    [anon_sym_STAR] = ACTIONS(104),
    [anon_sym_QMARK] = ACTIONS(106),
    [anon_sym_PLUS] = ACTIONS(108),
    [anon_sym_BSLASH] = ACTIONS(110),
    [anon_sym_BSLASHk_LT] = ACTIONS(98),
    [sym_group_begin] = ACTIONS(98),
    [sym_group_end] = ACTIONS(98),
    [anon_sym_LBRACK] = ACTIONS(98),
    [anon_sym_CARET] = ACTIONS(98),
    [anon_sym_BSLASHb] = ACTIONS(98),
    [sym_character_class_escape] = ACTIONS(98),
    [anon_sym_BSLASH0] = ACTIONS(98),
    [sym_special_escape] = ACTIONS(98),
    [sym_end_assertion] = ACTIONS(98),
    [sym_non_boundary_assertion] = ACTIONS(98),
    [sym_any_character] = ACTIONS(98),
    [sym_non_syntax_character] = ACTIONS(98),
    [sym_null_character] = ACTIONS(98),
  },
  [21] = {
    [sym_zero_or_more] = STATE(73),
    [sym_one_or_more] = STATE(73),
    [sym_optional] = STATE(73),
    [sym_count_quantifier] = STATE(73),
    [ts_builtin_sym_end] = ACTIONS(112),
    [sym_disjunction_delimiter] = ACTIONS(112),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(114),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(114),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(102),
    [anon_sym_STAR] = ACTIONS(104),
    [anon_sym_QMARK] = ACTIONS(106),
    [anon_sym_PLUS] = ACTIONS(108),
    [anon_sym_BSLASH] = ACTIONS(116),
    [anon_sym_BSLASHk_LT] = ACTIONS(112),
    [sym_group_begin] = ACTIONS(112),
    [sym_group_end] = ACTIONS(112),
    [anon_sym_LBRACK] = ACTIONS(112),
    [anon_sym_CARET] = ACTIONS(112),
    [anon_sym_BSLASHb] = ACTIONS(112),
    [sym_character_class_escape] = ACTIONS(112),
    [anon_sym_BSLASH0] = ACTIONS(112),
    [sym_special_escape] = ACTIONS(112),
    [sym_end_assertion] = ACTIONS(112),
    [sym_non_boundary_assertion] = ACTIONS(112),
    [sym_any_character] = ACTIONS(112),
    [sym_non_syntax_character] = ACTIONS(112),
    [sym_null_character] = ACTIONS(112),
  },
  [22] = {
    [sym_zero_or_more] = STATE(72),
    [sym_one_or_more] = STATE(72),
    [sym_optional] = STATE(72),
    [sym_count_quantifier] = STATE(72),
    [ts_builtin_sym_end] = ACTIONS(118),
    [sym_disjunction_delimiter] = ACTIONS(118),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(120),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(120),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(102),
    [anon_sym_STAR] = ACTIONS(104),
    [anon_sym_QMARK] = ACTIONS(106),
    [anon_sym_PLUS] = ACTIONS(108),
    [anon_sym_BSLASH] = ACTIONS(122),
    [anon_sym_BSLASHk_LT] = ACTIONS(118),
    [sym_group_begin] = ACTIONS(118),
    [sym_group_end] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_BSLASHb] = ACTIONS(118),
    [sym_character_class_escape] = ACTIONS(118),
    [anon_sym_BSLASH0] = ACTIONS(118),
    [sym_special_escape] = ACTIONS(118),
    [sym_end_assertion] = ACTIONS(118),
    [sym_non_boundary_assertion] = ACTIONS(118),
    [sym_any_character] = ACTIONS(118),
    [sym_non_syntax_character] = ACTIONS(118),
    [sym_null_character] = ACTIONS(118),
  },
  [23] = {
    [sym_zero_or_more] = STATE(71),
    [sym_one_or_more] = STATE(71),
    [sym_optional] = STATE(71),
    [sym_count_quantifier] = STATE(71),
    [ts_builtin_sym_end] = ACTIONS(98),
    [sym_disjunction_delimiter] = ACTIONS(98),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(100),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(100),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(100),
    [anon_sym_LBRACE] = ACTIONS(102),
    [anon_sym_STAR] = ACTIONS(104),
    [anon_sym_QMARK] = ACTIONS(106),
    [anon_sym_PLUS] = ACTIONS(108),
    [anon_sym_BSLASH] = ACTIONS(110),
    [anon_sym_BSLASHk_LT] = ACTIONS(98),
    [sym_group_begin] = ACTIONS(98),
    [sym_group_end] = ACTIONS(98),
    [anon_sym_LBRACK] = ACTIONS(98),
    [anon_sym_CARET] = ACTIONS(98),
    [anon_sym_BSLASHb] = ACTIONS(98),
    [sym_character_class_escape] = ACTIONS(98),
    [anon_sym_BSLASH0] = ACTIONS(98),
    [sym_special_escape] = ACTIONS(98),
    [sym_end_assertion] = ACTIONS(98),
    [sym_non_boundary_assertion] = ACTIONS(98),
    [sym_any_character] = ACTIONS(98),
    [sym_non_syntax_character] = ACTIONS(98),
    [sym_null_character] = ACTIONS(98),
  },
  [24] = {
    [ts_builtin_sym_end] = ACTIONS(124),
    [sym_disjunction_delimiter] = ACTIONS(124),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(124),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(124),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(124),
    [anon_sym_LBRACE] = ACTIONS(126),
    [anon_sym_STAR] = ACTIONS(124),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_PLUS] = ACTIONS(124),
    [anon_sym_BSLASH] = ACTIONS(126),
    [anon_sym_BSLASHk_LT] = ACTIONS(124),
    [sym_group_begin] = ACTIONS(124),
    [sym_group_end] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(124),
    [anon_sym_CARET] = ACTIONS(124),
    [anon_sym_BSLASHb] = ACTIONS(124),
    [sym_character_class_escape] = ACTIONS(124),
    [anon_sym_BSLASH0] = ACTIONS(124),
    [sym_special_escape] = ACTIONS(124),
    [sym_end_assertion] = ACTIONS(124),
    [sym_non_boundary_assertion] = ACTIONS(124),
    [sym_any_character] = ACTIONS(124),
    [sym_non_syntax_character] = ACTIONS(124),
    [sym_null_character] = ACTIONS(124),
  },
  [25] = {
    [ts_builtin_sym_end] = ACTIONS(128),
    [sym_disjunction_delimiter] = ACTIONS(128),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(128),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(128),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(128),
    [anon_sym_LBRACE] = ACTIONS(130),
    [anon_sym_STAR] = ACTIONS(128),
    [anon_sym_QMARK] = ACTIONS(128),
    [anon_sym_PLUS] = ACTIONS(128),
    [anon_sym_BSLASH] = ACTIONS(130),
    [anon_sym_BSLASHk_LT] = ACTIONS(128),
    [sym_group_begin] = ACTIONS(128),
    [sym_group_end] = ACTIONS(128),
    [anon_sym_LBRACK] = ACTIONS(128),
    [anon_sym_CARET] = ACTIONS(128),
    [anon_sym_BSLASHb] = ACTIONS(128),
    [sym_character_class_escape] = ACTIONS(128),
    [anon_sym_BSLASH0] = ACTIONS(128),
    [sym_special_escape] = ACTIONS(128),
    [sym_end_assertion] = ACTIONS(128),
    [sym_non_boundary_assertion] = ACTIONS(128),
    [sym_any_character] = ACTIONS(128),
    [sym_non_syntax_character] = ACTIONS(128),
    [sym_null_character] = ACTIONS(128),
  },
  [26] = {
    [ts_builtin_sym_end] = ACTIONS(132),
    [sym_disjunction_delimiter] = ACTIONS(132),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(132),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(132),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(132),
    [anon_sym_LBRACE] = ACTIONS(134),
    [anon_sym_STAR] = ACTIONS(132),
    [anon_sym_QMARK] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(132),
    [anon_sym_BSLASH] = ACTIONS(134),
    [anon_sym_BSLASHk_LT] = ACTIONS(132),
    [sym_group_begin] = ACTIONS(132),
    [sym_group_end] = ACTIONS(132),
    [anon_sym_LBRACK] = ACTIONS(132),
    [anon_sym_CARET] = ACTIONS(132),
    [anon_sym_BSLASHb] = ACTIONS(132),
    [sym_character_class_escape] = ACTIONS(132),
    [anon_sym_BSLASH0] = ACTIONS(132),
    [sym_special_escape] = ACTIONS(132),
    [sym_end_assertion] = ACTIONS(132),
    [sym_non_boundary_assertion] = ACTIONS(132),
    [sym_any_character] = ACTIONS(132),
    [sym_non_syntax_character] = ACTIONS(132),
    [sym_null_character] = ACTIONS(132),
  },
  [27] = {
    [ts_builtin_sym_end] = ACTIONS(136),
    [sym_disjunction_delimiter] = ACTIONS(136),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(136),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(136),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(136),
    [anon_sym_LBRACE] = ACTIONS(138),
    [anon_sym_STAR] = ACTIONS(136),
    [anon_sym_QMARK] = ACTIONS(136),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_BSLASH] = ACTIONS(138),
    [anon_sym_BSLASHk_LT] = ACTIONS(136),
    [sym_group_begin] = ACTIONS(136),
    [sym_group_end] = ACTIONS(136),
    [anon_sym_LBRACK] = ACTIONS(136),
    [anon_sym_CARET] = ACTIONS(136),
    [anon_sym_BSLASHb] = ACTIONS(136),
    [sym_character_class_escape] = ACTIONS(136),
    [anon_sym_BSLASH0] = ACTIONS(136),
    [sym_special_escape] = ACTIONS(136),
    [sym_end_assertion] = ACTIONS(136),
    [sym_non_boundary_assertion] = ACTIONS(136),
    [sym_any_character] = ACTIONS(136),
    [sym_non_syntax_character] = ACTIONS(136),
    [sym_null_character] = ACTIONS(136),
  },
  [28] = {
    [ts_builtin_sym_end] = ACTIONS(140),
    [sym_disjunction_delimiter] = ACTIONS(140),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(140),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(140),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(140),
    [anon_sym_LBRACE] = ACTIONS(142),
    [anon_sym_STAR] = ACTIONS(140),
    [anon_sym_QMARK] = ACTIONS(140),
    [anon_sym_PLUS] = ACTIONS(140),
    [anon_sym_BSLASH] = ACTIONS(142),
    [anon_sym_BSLASHk_LT] = ACTIONS(140),
    [sym_group_begin] = ACTIONS(140),
    [sym_group_end] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(140),
    [anon_sym_CARET] = ACTIONS(140),
    [anon_sym_BSLASHb] = ACTIONS(140),
    [sym_character_class_escape] = ACTIONS(140),
    [anon_sym_BSLASH0] = ACTIONS(140),
    [sym_special_escape] = ACTIONS(140),
    [sym_end_assertion] = ACTIONS(140),
    [sym_non_boundary_assertion] = ACTIONS(140),
    [sym_any_character] = ACTIONS(140),
    [sym_non_syntax_character] = ACTIONS(140),
    [sym_null_character] = ACTIONS(140),
  },
  [29] = {
    [ts_builtin_sym_end] = ACTIONS(144),
    [sym_disjunction_delimiter] = ACTIONS(144),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(144),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(144),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(144),
    [anon_sym_LBRACE] = ACTIONS(146),
    [anon_sym_STAR] = ACTIONS(144),
    [anon_sym_QMARK] = ACTIONS(144),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_BSLASH] = ACTIONS(146),
    [anon_sym_BSLASHk_LT] = ACTIONS(144),
    [sym_group_begin] = ACTIONS(144),
    [sym_group_end] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(144),
    [anon_sym_CARET] = ACTIONS(144),
    [anon_sym_BSLASHb] = ACTIONS(144),
    [sym_character_class_escape] = ACTIONS(144),
    [anon_sym_BSLASH0] = ACTIONS(144),
    [sym_special_escape] = ACTIONS(144),
    [sym_end_assertion] = ACTIONS(144),
    [sym_non_boundary_assertion] = ACTIONS(144),
    [sym_any_character] = ACTIONS(144),
    [sym_non_syntax_character] = ACTIONS(144),
    [sym_null_character] = ACTIONS(144),
  },
  [30] = {
    [ts_builtin_sym_end] = ACTIONS(148),
    [sym_disjunction_delimiter] = ACTIONS(148),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(148),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(148),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(150),
    [anon_sym_STAR] = ACTIONS(148),
    [anon_sym_QMARK] = ACTIONS(148),
    [anon_sym_PLUS] = ACTIONS(148),
    [anon_sym_BSLASH] = ACTIONS(150),
    [anon_sym_BSLASHk_LT] = ACTIONS(148),
    [sym_group_begin] = ACTIONS(148),
    [sym_group_end] = ACTIONS(148),
    [anon_sym_LBRACK] = ACTIONS(148),
    [anon_sym_CARET] = ACTIONS(148),
    [anon_sym_BSLASHb] = ACTIONS(148),
    [sym_character_class_escape] = ACTIONS(148),
    [anon_sym_BSLASH0] = ACTIONS(148),
    [sym_special_escape] = ACTIONS(148),
    [sym_end_assertion] = ACTIONS(148),
    [sym_non_boundary_assertion] = ACTIONS(148),
    [sym_any_character] = ACTIONS(148),
    [sym_non_syntax_character] = ACTIONS(148),
    [sym_null_character] = ACTIONS(148),
  },
  [31] = {
    [ts_builtin_sym_end] = ACTIONS(152),
    [sym_disjunction_delimiter] = ACTIONS(152),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(152),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(152),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(152),
    [anon_sym_LBRACE] = ACTIONS(154),
    [anon_sym_STAR] = ACTIONS(152),
    [anon_sym_QMARK] = ACTIONS(152),
    [anon_sym_PLUS] = ACTIONS(152),
    [anon_sym_BSLASH] = ACTIONS(154),
    [anon_sym_BSLASHk_LT] = ACTIONS(152),
    [sym_group_begin] = ACTIONS(152),
    [sym_group_end] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_CARET] = ACTIONS(152),
    [anon_sym_BSLASHb] = ACTIONS(152),
    [sym_character_class_escape] = ACTIONS(152),
    [anon_sym_BSLASH0] = ACTIONS(152),
    [sym_special_escape] = ACTIONS(152),
    [sym_end_assertion] = ACTIONS(152),
    [sym_non_boundary_assertion] = ACTIONS(152),
    [sym_any_character] = ACTIONS(152),
    [sym_non_syntax_character] = ACTIONS(152),
    [sym_null_character] = ACTIONS(152),
  },
  [32] = {
    [ts_builtin_sym_end] = ACTIONS(156),
    [sym_disjunction_delimiter] = ACTIONS(156),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(156),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(156),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(156),
    [anon_sym_LBRACE] = ACTIONS(158),
    [anon_sym_STAR] = ACTIONS(156),
    [anon_sym_QMARK] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(156),
    [anon_sym_BSLASH] = ACTIONS(158),
    [anon_sym_BSLASHk_LT] = ACTIONS(156),
    [sym_group_begin] = ACTIONS(156),
    [sym_group_end] = ACTIONS(156),
    [anon_sym_LBRACK] = ACTIONS(156),
    [anon_sym_CARET] = ACTIONS(156),
    [anon_sym_BSLASHb] = ACTIONS(156),
    [sym_character_class_escape] = ACTIONS(156),
    [anon_sym_BSLASH0] = ACTIONS(156),
    [sym_special_escape] = ACTIONS(156),
    [sym_end_assertion] = ACTIONS(156),
    [sym_non_boundary_assertion] = ACTIONS(156),
    [sym_any_character] = ACTIONS(156),
    [sym_non_syntax_character] = ACTIONS(156),
    [sym_null_character] = ACTIONS(156),
  },
  [33] = {
    [ts_builtin_sym_end] = ACTIONS(160),
    [sym_disjunction_delimiter] = ACTIONS(160),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(160),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(160),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(160),
    [anon_sym_LBRACE] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(160),
    [anon_sym_QMARK] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(160),
    [anon_sym_BSLASH] = ACTIONS(162),
    [anon_sym_BSLASHk_LT] = ACTIONS(160),
    [sym_group_begin] = ACTIONS(160),
    [sym_group_end] = ACTIONS(160),
    [anon_sym_LBRACK] = ACTIONS(160),
    [anon_sym_CARET] = ACTIONS(160),
    [anon_sym_BSLASHb] = ACTIONS(160),
    [sym_character_class_escape] = ACTIONS(160),
    [anon_sym_BSLASH0] = ACTIONS(160),
    [sym_special_escape] = ACTIONS(160),
    [sym_end_assertion] = ACTIONS(160),
    [sym_non_boundary_assertion] = ACTIONS(160),
    [sym_any_character] = ACTIONS(160),
    [sym_non_syntax_character] = ACTIONS(160),
    [sym_null_character] = ACTIONS(160),
  },
  [34] = {
    [ts_builtin_sym_end] = ACTIONS(164),
    [sym_disjunction_delimiter] = ACTIONS(164),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(164),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(164),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(164),
    [anon_sym_LBRACE] = ACTIONS(166),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_PLUS] = ACTIONS(164),
    [anon_sym_BSLASH] = ACTIONS(166),
    [anon_sym_BSLASHk_LT] = ACTIONS(164),
    [sym_group_begin] = ACTIONS(164),
    [sym_group_end] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(164),
    [anon_sym_CARET] = ACTIONS(164),
    [anon_sym_BSLASHb] = ACTIONS(164),
    [sym_character_class_escape] = ACTIONS(164),
    [anon_sym_BSLASH0] = ACTIONS(164),
    [sym_special_escape] = ACTIONS(164),
    [sym_end_assertion] = ACTIONS(164),
    [sym_non_boundary_assertion] = ACTIONS(164),
    [sym_any_character] = ACTIONS(164),
    [sym_non_syntax_character] = ACTIONS(164),
    [sym_null_character] = ACTIONS(164),
  },
  [35] = {
    [ts_builtin_sym_end] = ACTIONS(168),
    [sym_disjunction_delimiter] = ACTIONS(168),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(168),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(168),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(168),
    [anon_sym_LBRACE] = ACTIONS(170),
    [anon_sym_STAR] = ACTIONS(168),
    [anon_sym_QMARK] = ACTIONS(168),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_BSLASH] = ACTIONS(170),
    [anon_sym_BSLASHk_LT] = ACTIONS(168),
    [sym_group_begin] = ACTIONS(168),
    [sym_group_end] = ACTIONS(168),
    [anon_sym_LBRACK] = ACTIONS(168),
    [anon_sym_CARET] = ACTIONS(168),
    [anon_sym_BSLASHb] = ACTIONS(168),
    [sym_character_class_escape] = ACTIONS(168),
    [anon_sym_BSLASH0] = ACTIONS(168),
    [sym_special_escape] = ACTIONS(168),
    [sym_end_assertion] = ACTIONS(168),
    [sym_non_boundary_assertion] = ACTIONS(168),
    [sym_any_character] = ACTIONS(168),
    [sym_non_syntax_character] = ACTIONS(168),
    [sym_null_character] = ACTIONS(168),
  },
  [36] = {
    [ts_builtin_sym_end] = ACTIONS(172),
    [sym_disjunction_delimiter] = ACTIONS(172),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(172),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(172),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(172),
    [anon_sym_LBRACE] = ACTIONS(174),
    [anon_sym_STAR] = ACTIONS(172),
    [anon_sym_QMARK] = ACTIONS(172),
    [anon_sym_PLUS] = ACTIONS(172),
    [anon_sym_BSLASH] = ACTIONS(174),
    [anon_sym_BSLASHk_LT] = ACTIONS(172),
    [sym_group_begin] = ACTIONS(172),
    [sym_group_end] = ACTIONS(172),
    [anon_sym_LBRACK] = ACTIONS(172),
    [anon_sym_CARET] = ACTIONS(172),
    [anon_sym_BSLASHb] = ACTIONS(172),
    [sym_character_class_escape] = ACTIONS(172),
    [anon_sym_BSLASH0] = ACTIONS(172),
    [sym_special_escape] = ACTIONS(172),
    [sym_end_assertion] = ACTIONS(172),
    [sym_non_boundary_assertion] = ACTIONS(172),
    [sym_any_character] = ACTIONS(172),
    [sym_non_syntax_character] = ACTIONS(172),
    [sym_null_character] = ACTIONS(172),
  },
  [37] = {
    [ts_builtin_sym_end] = ACTIONS(176),
    [sym_disjunction_delimiter] = ACTIONS(176),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(176),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(176),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(176),
    [anon_sym_LBRACE] = ACTIONS(178),
    [anon_sym_STAR] = ACTIONS(176),
    [anon_sym_QMARK] = ACTIONS(176),
    [anon_sym_PLUS] = ACTIONS(176),
    [anon_sym_BSLASH] = ACTIONS(178),
    [anon_sym_BSLASHk_LT] = ACTIONS(176),
    [sym_group_begin] = ACTIONS(176),
    [sym_group_end] = ACTIONS(176),
    [anon_sym_LBRACK] = ACTIONS(176),
    [anon_sym_CARET] = ACTIONS(176),
    [anon_sym_BSLASHb] = ACTIONS(176),
    [sym_character_class_escape] = ACTIONS(176),
    [anon_sym_BSLASH0] = ACTIONS(176),
    [sym_special_escape] = ACTIONS(176),
    [sym_end_assertion] = ACTIONS(176),
    [sym_non_boundary_assertion] = ACTIONS(176),
    [sym_any_character] = ACTIONS(176),
    [sym_non_syntax_character] = ACTIONS(176),
    [sym_null_character] = ACTIONS(176),
  },
  [38] = {
    [ts_builtin_sym_end] = ACTIONS(180),
    [sym_disjunction_delimiter] = ACTIONS(180),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(180),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(180),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(180),
    [anon_sym_LBRACE] = ACTIONS(182),
    [anon_sym_STAR] = ACTIONS(180),
    [anon_sym_QMARK] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_BSLASH] = ACTIONS(182),
    [anon_sym_BSLASHk_LT] = ACTIONS(180),
    [sym_group_begin] = ACTIONS(180),
    [sym_group_end] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(180),
    [anon_sym_CARET] = ACTIONS(180),
    [anon_sym_BSLASHb] = ACTIONS(180),
    [sym_character_class_escape] = ACTIONS(180),
    [anon_sym_BSLASH0] = ACTIONS(180),
    [sym_special_escape] = ACTIONS(180),
    [sym_end_assertion] = ACTIONS(180),
    [sym_non_boundary_assertion] = ACTIONS(180),
    [sym_any_character] = ACTIONS(180),
    [sym_non_syntax_character] = ACTIONS(180),
    [sym_null_character] = ACTIONS(180),
  },
  [39] = {
    [ts_builtin_sym_end] = ACTIONS(184),
    [sym_disjunction_delimiter] = ACTIONS(184),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(184),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(184),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(184),
    [anon_sym_LBRACE] = ACTIONS(186),
    [anon_sym_STAR] = ACTIONS(184),
    [anon_sym_QMARK] = ACTIONS(184),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_BSLASHk_LT] = ACTIONS(184),
    [sym_group_begin] = ACTIONS(184),
    [sym_group_end] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(184),
    [anon_sym_CARET] = ACTIONS(184),
    [anon_sym_BSLASHb] = ACTIONS(184),
    [sym_character_class_escape] = ACTIONS(184),
    [anon_sym_BSLASH0] = ACTIONS(184),
    [sym_special_escape] = ACTIONS(184),
    [sym_end_assertion] = ACTIONS(184),
    [sym_non_boundary_assertion] = ACTIONS(184),
    [sym_any_character] = ACTIONS(184),
    [sym_non_syntax_character] = ACTIONS(184),
    [sym_null_character] = ACTIONS(184),
  },
  [40] = {
    [ts_builtin_sym_end] = ACTIONS(188),
    [sym_disjunction_delimiter] = ACTIONS(188),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(188),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(188),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(188),
    [anon_sym_LBRACE] = ACTIONS(190),
    [anon_sym_STAR] = ACTIONS(188),
    [anon_sym_QMARK] = ACTIONS(188),
    [anon_sym_PLUS] = ACTIONS(188),
    [anon_sym_BSLASH] = ACTIONS(190),
    [anon_sym_BSLASHk_LT] = ACTIONS(188),
    [sym_group_begin] = ACTIONS(188),
    [sym_group_end] = ACTIONS(188),
    [anon_sym_LBRACK] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(188),
    [anon_sym_BSLASHb] = ACTIONS(188),
    [sym_character_class_escape] = ACTIONS(188),
    [anon_sym_BSLASH0] = ACTIONS(188),
    [sym_special_escape] = ACTIONS(188),
    [sym_end_assertion] = ACTIONS(188),
    [sym_non_boundary_assertion] = ACTIONS(188),
    [sym_any_character] = ACTIONS(188),
    [sym_non_syntax_character] = ACTIONS(188),
    [sym_null_character] = ACTIONS(188),
  },
  [41] = {
    [ts_builtin_sym_end] = ACTIONS(192),
    [sym_disjunction_delimiter] = ACTIONS(192),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(192),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(192),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(192),
    [anon_sym_LBRACE] = ACTIONS(194),
    [anon_sym_STAR] = ACTIONS(192),
    [anon_sym_QMARK] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_BSLASH] = ACTIONS(194),
    [anon_sym_BSLASHk_LT] = ACTIONS(192),
    [sym_group_begin] = ACTIONS(192),
    [sym_group_end] = ACTIONS(192),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_CARET] = ACTIONS(192),
    [anon_sym_BSLASHb] = ACTIONS(192),
    [sym_character_class_escape] = ACTIONS(192),
    [anon_sym_BSLASH0] = ACTIONS(192),
    [sym_special_escape] = ACTIONS(192),
    [sym_end_assertion] = ACTIONS(192),
    [sym_non_boundary_assertion] = ACTIONS(192),
    [sym_any_character] = ACTIONS(192),
    [sym_non_syntax_character] = ACTIONS(192),
    [sym_null_character] = ACTIONS(192),
  },
  [42] = {
    [ts_builtin_sym_end] = ACTIONS(196),
    [sym_disjunction_delimiter] = ACTIONS(196),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(196),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(196),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(196),
    [anon_sym_LBRACE] = ACTIONS(198),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_QMARK] = ACTIONS(196),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_BSLASH] = ACTIONS(198),
    [anon_sym_BSLASHk_LT] = ACTIONS(196),
    [sym_group_begin] = ACTIONS(196),
    [sym_group_end] = ACTIONS(196),
    [anon_sym_LBRACK] = ACTIONS(196),
    [anon_sym_CARET] = ACTIONS(196),
    [anon_sym_BSLASHb] = ACTIONS(196),
    [sym_character_class_escape] = ACTIONS(196),
    [anon_sym_BSLASH0] = ACTIONS(196),
    [sym_special_escape] = ACTIONS(196),
    [sym_end_assertion] = ACTIONS(196),
    [sym_non_boundary_assertion] = ACTIONS(196),
    [sym_any_character] = ACTIONS(196),
    [sym_non_syntax_character] = ACTIONS(196),
    [sym_null_character] = ACTIONS(196),
  },
  [43] = {
    [ts_builtin_sym_end] = ACTIONS(200),
    [sym_disjunction_delimiter] = ACTIONS(200),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(200),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(200),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(200),
    [anon_sym_LBRACE] = ACTIONS(202),
    [anon_sym_STAR] = ACTIONS(200),
    [anon_sym_QMARK] = ACTIONS(200),
    [anon_sym_PLUS] = ACTIONS(200),
    [anon_sym_BSLASH] = ACTIONS(202),
    [anon_sym_BSLASHk_LT] = ACTIONS(200),
    [sym_group_begin] = ACTIONS(200),
    [sym_group_end] = ACTIONS(200),
    [anon_sym_LBRACK] = ACTIONS(200),
    [anon_sym_CARET] = ACTIONS(200),
    [anon_sym_BSLASHb] = ACTIONS(200),
    [sym_character_class_escape] = ACTIONS(200),
    [anon_sym_BSLASH0] = ACTIONS(200),
    [sym_special_escape] = ACTIONS(200),
    [sym_end_assertion] = ACTIONS(200),
    [sym_non_boundary_assertion] = ACTIONS(200),
    [sym_any_character] = ACTIONS(200),
    [sym_non_syntax_character] = ACTIONS(200),
    [sym_null_character] = ACTIONS(200),
  },
  [44] = {
    [ts_builtin_sym_end] = ACTIONS(204),
    [sym_disjunction_delimiter] = ACTIONS(204),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(204),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(204),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(204),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_QMARK] = ACTIONS(204),
    [anon_sym_PLUS] = ACTIONS(204),
    [anon_sym_BSLASH] = ACTIONS(206),
    [anon_sym_BSLASHk_LT] = ACTIONS(204),
    [sym_group_begin] = ACTIONS(204),
    [sym_group_end] = ACTIONS(204),
    [anon_sym_LBRACK] = ACTIONS(204),
    [anon_sym_CARET] = ACTIONS(204),
    [anon_sym_BSLASHb] = ACTIONS(204),
    [sym_character_class_escape] = ACTIONS(204),
    [anon_sym_BSLASH0] = ACTIONS(204),
    [sym_special_escape] = ACTIONS(204),
    [sym_end_assertion] = ACTIONS(204),
    [sym_non_boundary_assertion] = ACTIONS(204),
    [sym_any_character] = ACTIONS(204),
    [sym_non_syntax_character] = ACTIONS(204),
    [sym_null_character] = ACTIONS(204),
  },
  [45] = {
    [ts_builtin_sym_end] = ACTIONS(208),
    [sym_disjunction_delimiter] = ACTIONS(208),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(208),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(208),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(208),
    [anon_sym_LBRACE] = ACTIONS(210),
    [anon_sym_STAR] = ACTIONS(208),
    [anon_sym_QMARK] = ACTIONS(208),
    [anon_sym_PLUS] = ACTIONS(208),
    [anon_sym_BSLASH] = ACTIONS(210),
    [anon_sym_BSLASHk_LT] = ACTIONS(208),
    [sym_group_begin] = ACTIONS(208),
    [sym_group_end] = ACTIONS(208),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_CARET] = ACTIONS(208),
    [anon_sym_BSLASHb] = ACTIONS(208),
    [sym_character_class_escape] = ACTIONS(208),
    [anon_sym_BSLASH0] = ACTIONS(208),
    [sym_special_escape] = ACTIONS(208),
    [sym_end_assertion] = ACTIONS(208),
    [sym_non_boundary_assertion] = ACTIONS(208),
    [sym_any_character] = ACTIONS(208),
    [sym_non_syntax_character] = ACTIONS(208),
    [sym_null_character] = ACTIONS(208),
  },
  [46] = {
    [ts_builtin_sym_end] = ACTIONS(212),
    [sym_disjunction_delimiter] = ACTIONS(212),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(212),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(212),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(212),
    [anon_sym_LBRACE] = ACTIONS(214),
    [anon_sym_STAR] = ACTIONS(212),
    [anon_sym_QMARK] = ACTIONS(212),
    [anon_sym_PLUS] = ACTIONS(212),
    [anon_sym_BSLASH] = ACTIONS(214),
    [anon_sym_BSLASHk_LT] = ACTIONS(212),
    [sym_group_begin] = ACTIONS(212),
    [sym_group_end] = ACTIONS(212),
    [anon_sym_LBRACK] = ACTIONS(212),
    [anon_sym_CARET] = ACTIONS(212),
    [anon_sym_BSLASHb] = ACTIONS(212),
    [sym_character_class_escape] = ACTIONS(212),
    [anon_sym_BSLASH0] = ACTIONS(212),
    [sym_special_escape] = ACTIONS(212),
    [sym_end_assertion] = ACTIONS(212),
    [sym_non_boundary_assertion] = ACTIONS(212),
    [sym_any_character] = ACTIONS(212),
    [sym_non_syntax_character] = ACTIONS(212),
    [sym_null_character] = ACTIONS(212),
  },
  [47] = {
    [ts_builtin_sym_end] = ACTIONS(216),
    [sym_disjunction_delimiter] = ACTIONS(216),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(216),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(216),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(216),
    [anon_sym_LBRACE] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(216),
    [anon_sym_QMARK] = ACTIONS(216),
    [anon_sym_PLUS] = ACTIONS(216),
    [anon_sym_BSLASH] = ACTIONS(218),
    [anon_sym_BSLASHk_LT] = ACTIONS(216),
    [sym_group_begin] = ACTIONS(216),
    [sym_group_end] = ACTIONS(216),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_CARET] = ACTIONS(216),
    [anon_sym_BSLASHb] = ACTIONS(216),
    [sym_character_class_escape] = ACTIONS(216),
    [anon_sym_BSLASH0] = ACTIONS(216),
    [sym_special_escape] = ACTIONS(216),
    [sym_end_assertion] = ACTIONS(216),
    [sym_non_boundary_assertion] = ACTIONS(216),
    [sym_any_character] = ACTIONS(216),
    [sym_non_syntax_character] = ACTIONS(216),
    [sym_null_character] = ACTIONS(216),
  },
  [48] = {
    [ts_builtin_sym_end] = ACTIONS(220),
    [sym_disjunction_delimiter] = ACTIONS(220),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(220),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(220),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(220),
    [anon_sym_QMARK] = ACTIONS(220),
    [anon_sym_PLUS] = ACTIONS(220),
    [anon_sym_BSLASH] = ACTIONS(222),
    [anon_sym_BSLASHk_LT] = ACTIONS(220),
    [sym_group_begin] = ACTIONS(220),
    [sym_group_end] = ACTIONS(220),
    [anon_sym_LBRACK] = ACTIONS(220),
    [anon_sym_CARET] = ACTIONS(220),
    [anon_sym_BSLASHb] = ACTIONS(220),
    [sym_character_class_escape] = ACTIONS(220),
    [anon_sym_BSLASH0] = ACTIONS(220),
    [sym_special_escape] = ACTIONS(220),
    [sym_end_assertion] = ACTIONS(220),
    [sym_non_boundary_assertion] = ACTIONS(220),
    [sym_any_character] = ACTIONS(220),
    [sym_non_syntax_character] = ACTIONS(220),
    [sym_null_character] = ACTIONS(220),
  },
  [49] = {
    [ts_builtin_sym_end] = ACTIONS(224),
    [sym_disjunction_delimiter] = ACTIONS(224),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(224),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(224),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(224),
    [anon_sym_LBRACE] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_QMARK] = ACTIONS(224),
    [anon_sym_PLUS] = ACTIONS(224),
    [anon_sym_BSLASH] = ACTIONS(226),
    [anon_sym_BSLASHk_LT] = ACTIONS(224),
    [sym_group_begin] = ACTIONS(224),
    [sym_group_end] = ACTIONS(224),
    [anon_sym_LBRACK] = ACTIONS(224),
    [anon_sym_CARET] = ACTIONS(224),
    [anon_sym_BSLASHb] = ACTIONS(224),
    [sym_character_class_escape] = ACTIONS(224),
    [anon_sym_BSLASH0] = ACTIONS(224),
    [sym_special_escape] = ACTIONS(224),
    [sym_end_assertion] = ACTIONS(224),
    [sym_non_boundary_assertion] = ACTIONS(224),
    [sym_any_character] = ACTIONS(224),
    [sym_non_syntax_character] = ACTIONS(224),
    [sym_null_character] = ACTIONS(224),
  },
  [50] = {
    [ts_builtin_sym_end] = ACTIONS(228),
    [sym_disjunction_delimiter] = ACTIONS(228),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(228),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(228),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(230),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_QMARK] = ACTIONS(228),
    [anon_sym_PLUS] = ACTIONS(228),
    [anon_sym_BSLASH] = ACTIONS(230),
    [anon_sym_BSLASHk_LT] = ACTIONS(228),
    [sym_group_begin] = ACTIONS(228),
    [sym_group_end] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(228),
    [anon_sym_CARET] = ACTIONS(228),
    [anon_sym_BSLASHb] = ACTIONS(228),
    [sym_character_class_escape] = ACTIONS(228),
    [anon_sym_BSLASH0] = ACTIONS(228),
    [sym_special_escape] = ACTIONS(228),
    [sym_end_assertion] = ACTIONS(228),
    [sym_non_boundary_assertion] = ACTIONS(228),
    [sym_any_character] = ACTIONS(228),
    [sym_non_syntax_character] = ACTIONS(228),
    [sym_null_character] = ACTIONS(228),
  },
  [51] = {
    [ts_builtin_sym_end] = ACTIONS(232),
    [sym_disjunction_delimiter] = ACTIONS(232),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(232),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(232),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(232),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_STAR] = ACTIONS(232),
    [anon_sym_QMARK] = ACTIONS(232),
    [anon_sym_PLUS] = ACTIONS(232),
    [anon_sym_BSLASH] = ACTIONS(234),
    [anon_sym_BSLASHk_LT] = ACTIONS(232),
    [sym_group_begin] = ACTIONS(232),
    [sym_group_end] = ACTIONS(232),
    [anon_sym_LBRACK] = ACTIONS(232),
    [anon_sym_CARET] = ACTIONS(232),
    [anon_sym_BSLASHb] = ACTIONS(232),
    [sym_character_class_escape] = ACTIONS(232),
    [anon_sym_BSLASH0] = ACTIONS(232),
    [sym_special_escape] = ACTIONS(232),
    [sym_end_assertion] = ACTIONS(232),
    [sym_non_boundary_assertion] = ACTIONS(232),
    [sym_any_character] = ACTIONS(232),
    [sym_non_syntax_character] = ACTIONS(232),
    [sym_null_character] = ACTIONS(232),
  },
  [52] = {
    [ts_builtin_sym_end] = ACTIONS(236),
    [sym_disjunction_delimiter] = ACTIONS(236),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(236),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(236),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(236),
    [anon_sym_LBRACE] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_QMARK] = ACTIONS(236),
    [anon_sym_PLUS] = ACTIONS(236),
    [anon_sym_BSLASH] = ACTIONS(238),
    [anon_sym_BSLASHk_LT] = ACTIONS(236),
    [sym_group_begin] = ACTIONS(236),
    [sym_group_end] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(236),
    [anon_sym_CARET] = ACTIONS(236),
    [anon_sym_BSLASHb] = ACTIONS(236),
    [sym_character_class_escape] = ACTIONS(236),
    [anon_sym_BSLASH0] = ACTIONS(236),
    [sym_special_escape] = ACTIONS(236),
    [sym_end_assertion] = ACTIONS(236),
    [sym_non_boundary_assertion] = ACTIONS(236),
    [sym_any_character] = ACTIONS(236),
    [sym_non_syntax_character] = ACTIONS(236),
    [sym_null_character] = ACTIONS(236),
  },
  [53] = {
    [ts_builtin_sym_end] = ACTIONS(240),
    [sym_disjunction_delimiter] = ACTIONS(240),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(240),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(240),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(240),
    [anon_sym_LBRACE] = ACTIONS(242),
    [anon_sym_STAR] = ACTIONS(240),
    [anon_sym_QMARK] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(240),
    [anon_sym_BSLASH] = ACTIONS(242),
    [anon_sym_BSLASHk_LT] = ACTIONS(240),
    [sym_group_begin] = ACTIONS(240),
    [sym_group_end] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(240),
    [anon_sym_CARET] = ACTIONS(240),
    [anon_sym_BSLASHb] = ACTIONS(240),
    [sym_character_class_escape] = ACTIONS(240),
    [anon_sym_BSLASH0] = ACTIONS(240),
    [sym_special_escape] = ACTIONS(240),
    [sym_end_assertion] = ACTIONS(240),
    [sym_non_boundary_assertion] = ACTIONS(240),
    [sym_any_character] = ACTIONS(240),
    [sym_non_syntax_character] = ACTIONS(240),
    [sym_null_character] = ACTIONS(240),
  },
  [54] = {
    [ts_builtin_sym_end] = ACTIONS(244),
    [sym_disjunction_delimiter] = ACTIONS(244),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(244),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(244),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(244),
    [anon_sym_LBRACE] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(244),
    [anon_sym_QMARK] = ACTIONS(244),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_BSLASH] = ACTIONS(246),
    [anon_sym_BSLASHk_LT] = ACTIONS(244),
    [sym_group_begin] = ACTIONS(244),
    [sym_group_end] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_CARET] = ACTIONS(244),
    [anon_sym_BSLASHb] = ACTIONS(244),
    [sym_character_class_escape] = ACTIONS(244),
    [anon_sym_BSLASH0] = ACTIONS(244),
    [sym_special_escape] = ACTIONS(244),
    [sym_end_assertion] = ACTIONS(244),
    [sym_non_boundary_assertion] = ACTIONS(244),
    [sym_any_character] = ACTIONS(244),
    [sym_non_syntax_character] = ACTIONS(244),
    [sym_null_character] = ACTIONS(244),
  },
  [55] = {
    [ts_builtin_sym_end] = ACTIONS(248),
    [sym_disjunction_delimiter] = ACTIONS(248),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(248),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(248),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(248),
    [anon_sym_QMARK] = ACTIONS(248),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_BSLASH] = ACTIONS(250),
    [anon_sym_BSLASHk_LT] = ACTIONS(248),
    [sym_group_begin] = ACTIONS(248),
    [sym_group_end] = ACTIONS(248),
    [anon_sym_LBRACK] = ACTIONS(248),
    [anon_sym_CARET] = ACTIONS(248),
    [anon_sym_BSLASHb] = ACTIONS(248),
    [sym_character_class_escape] = ACTIONS(248),
    [anon_sym_BSLASH0] = ACTIONS(248),
    [sym_special_escape] = ACTIONS(248),
    [sym_end_assertion] = ACTIONS(248),
    [sym_non_boundary_assertion] = ACTIONS(248),
    [sym_any_character] = ACTIONS(248),
    [sym_non_syntax_character] = ACTIONS(248),
    [sym_null_character] = ACTIONS(248),
  },
  [56] = {
    [ts_builtin_sym_end] = ACTIONS(252),
    [sym_disjunction_delimiter] = ACTIONS(252),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(252),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(252),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(252),
    [anon_sym_LBRACE] = ACTIONS(254),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_QMARK] = ACTIONS(252),
    [anon_sym_PLUS] = ACTIONS(252),
    [anon_sym_BSLASH] = ACTIONS(254),
    [anon_sym_BSLASHk_LT] = ACTIONS(252),
    [sym_group_begin] = ACTIONS(252),
    [sym_group_end] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(252),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_BSLASHb] = ACTIONS(252),
    [sym_character_class_escape] = ACTIONS(252),
    [anon_sym_BSLASH0] = ACTIONS(252),
    [sym_special_escape] = ACTIONS(252),
    [sym_end_assertion] = ACTIONS(252),
    [sym_non_boundary_assertion] = ACTIONS(252),
    [sym_any_character] = ACTIONS(252),
    [sym_non_syntax_character] = ACTIONS(252),
    [sym_null_character] = ACTIONS(252),
  },
  [57] = {
    [ts_builtin_sym_end] = ACTIONS(256),
    [sym_disjunction_delimiter] = ACTIONS(256),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(256),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(256),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(256),
    [anon_sym_LBRACE] = ACTIONS(258),
    [anon_sym_STAR] = ACTIONS(256),
    [anon_sym_QMARK] = ACTIONS(256),
    [anon_sym_PLUS] = ACTIONS(256),
    [anon_sym_BSLASH] = ACTIONS(258),
    [anon_sym_BSLASHk_LT] = ACTIONS(256),
    [sym_group_begin] = ACTIONS(256),
    [sym_group_end] = ACTIONS(256),
    [anon_sym_LBRACK] = ACTIONS(256),
    [anon_sym_CARET] = ACTIONS(256),
    [anon_sym_BSLASHb] = ACTIONS(256),
    [sym_character_class_escape] = ACTIONS(256),
    [anon_sym_BSLASH0] = ACTIONS(256),
    [sym_special_escape] = ACTIONS(256),
    [sym_end_assertion] = ACTIONS(256),
    [sym_non_boundary_assertion] = ACTIONS(256),
    [sym_any_character] = ACTIONS(256),
    [sym_non_syntax_character] = ACTIONS(256),
    [sym_null_character] = ACTIONS(256),
  },
  [58] = {
    [ts_builtin_sym_end] = ACTIONS(260),
    [sym_disjunction_delimiter] = ACTIONS(260),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(262),
    [anon_sym_LBRACE] = ACTIONS(260),
    [anon_sym_QMARK] = ACTIONS(264),
    [anon_sym_BSLASH] = ACTIONS(262),
    [anon_sym_BSLASHk_LT] = ACTIONS(260),
    [sym_group_begin] = ACTIONS(260),
    [sym_group_end] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(260),
    [anon_sym_CARET] = ACTIONS(260),
    [anon_sym_BSLASHb] = ACTIONS(260),
    [sym_character_class_escape] = ACTIONS(260),
    [anon_sym_BSLASH0] = ACTIONS(260),
    [sym_special_escape] = ACTIONS(260),
    [sym_end_assertion] = ACTIONS(260),
    [sym_non_boundary_assertion] = ACTIONS(260),
    [sym_any_character] = ACTIONS(260),
    [sym_non_syntax_character] = ACTIONS(260),
    [sym_null_character] = ACTIONS(260),
  },
  [59] = {
    [ts_builtin_sym_end] = ACTIONS(266),
    [sym_disjunction_delimiter] = ACTIONS(266),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(266),
    [anon_sym_QMARK] = ACTIONS(270),
    [anon_sym_BSLASH] = ACTIONS(268),
    [anon_sym_BSLASHk_LT] = ACTIONS(266),
    [sym_group_begin] = ACTIONS(266),
    [sym_group_end] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(266),
    [anon_sym_CARET] = ACTIONS(266),
    [anon_sym_BSLASHb] = ACTIONS(266),
    [sym_character_class_escape] = ACTIONS(266),
    [anon_sym_BSLASH0] = ACTIONS(266),
    [sym_special_escape] = ACTIONS(266),
    [sym_end_assertion] = ACTIONS(266),
    [sym_non_boundary_assertion] = ACTIONS(266),
    [sym_any_character] = ACTIONS(266),
    [sym_non_syntax_character] = ACTIONS(266),
    [sym_null_character] = ACTIONS(266),
  },
  [60] = {
    [ts_builtin_sym_end] = ACTIONS(272),
    [sym_disjunction_delimiter] = ACTIONS(272),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(274),
    [anon_sym_LBRACE] = ACTIONS(272),
    [anon_sym_QMARK] = ACTIONS(276),
    [anon_sym_BSLASH] = ACTIONS(274),
    [anon_sym_BSLASHk_LT] = ACTIONS(272),
    [sym_group_begin] = ACTIONS(272),
    [sym_group_end] = ACTIONS(272),
    [anon_sym_LBRACK] = ACTIONS(272),
    [anon_sym_CARET] = ACTIONS(272),
    [anon_sym_BSLASHb] = ACTIONS(272),
    [sym_character_class_escape] = ACTIONS(272),
    [anon_sym_BSLASH0] = ACTIONS(272),
    [sym_special_escape] = ACTIONS(272),
    [sym_end_assertion] = ACTIONS(272),
    [sym_non_boundary_assertion] = ACTIONS(272),
    [sym_any_character] = ACTIONS(272),
    [sym_non_syntax_character] = ACTIONS(272),
    [sym_null_character] = ACTIONS(272),
  },
  [61] = {
    [ts_builtin_sym_end] = ACTIONS(278),
    [sym_disjunction_delimiter] = ACTIONS(278),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(278),
    [anon_sym_QMARK] = ACTIONS(282),
    [anon_sym_BSLASH] = ACTIONS(280),
    [anon_sym_BSLASHk_LT] = ACTIONS(278),
    [sym_group_begin] = ACTIONS(278),
    [sym_group_end] = ACTIONS(278),
    [anon_sym_LBRACK] = ACTIONS(278),
    [anon_sym_CARET] = ACTIONS(278),
    [anon_sym_BSLASHb] = ACTIONS(278),
    [sym_character_class_escape] = ACTIONS(278),
    [anon_sym_BSLASH0] = ACTIONS(278),
    [sym_special_escape] = ACTIONS(278),
    [sym_end_assertion] = ACTIONS(278),
    [sym_non_boundary_assertion] = ACTIONS(278),
    [sym_any_character] = ACTIONS(278),
    [sym_non_syntax_character] = ACTIONS(278),
    [sym_null_character] = ACTIONS(278),
  },
  [62] = {
    [ts_builtin_sym_end] = ACTIONS(284),
    [sym_disjunction_delimiter] = ACTIONS(284),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(284),
    [anon_sym_QMARK] = ACTIONS(288),
    [anon_sym_BSLASH] = ACTIONS(286),
    [anon_sym_BSLASHk_LT] = ACTIONS(284),
    [sym_group_begin] = ACTIONS(284),
    [sym_group_end] = ACTIONS(284),
    [anon_sym_LBRACK] = ACTIONS(284),
    [anon_sym_CARET] = ACTIONS(284),
    [anon_sym_BSLASHb] = ACTIONS(284),
    [sym_character_class_escape] = ACTIONS(284),
    [anon_sym_BSLASH0] = ACTIONS(284),
    [sym_special_escape] = ACTIONS(284),
    [sym_end_assertion] = ACTIONS(284),
    [sym_non_boundary_assertion] = ACTIONS(284),
    [sym_any_character] = ACTIONS(284),
    [sym_non_syntax_character] = ACTIONS(284),
    [sym_null_character] = ACTIONS(284),
  },
  [63] = {
    [ts_builtin_sym_end] = ACTIONS(290),
    [sym_disjunction_delimiter] = ACTIONS(290),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(292),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_QMARK] = ACTIONS(294),
    [anon_sym_BSLASH] = ACTIONS(292),
    [anon_sym_BSLASHk_LT] = ACTIONS(290),
    [sym_group_begin] = ACTIONS(290),
    [sym_group_end] = ACTIONS(290),
    [anon_sym_LBRACK] = ACTIONS(290),
    [anon_sym_CARET] = ACTIONS(290),
    [anon_sym_BSLASHb] = ACTIONS(290),
    [sym_character_class_escape] = ACTIONS(290),
    [anon_sym_BSLASH0] = ACTIONS(290),
    [sym_special_escape] = ACTIONS(290),
    [sym_end_assertion] = ACTIONS(290),
    [sym_non_boundary_assertion] = ACTIONS(290),
    [sym_any_character] = ACTIONS(290),
    [sym_non_syntax_character] = ACTIONS(290),
    [sym_null_character] = ACTIONS(290),
  },
  [64] = {
    [ts_builtin_sym_end] = ACTIONS(296),
    [sym_disjunction_delimiter] = ACTIONS(296),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(296),
    [anon_sym_LBRACE] = ACTIONS(296),
    [anon_sym_BSLASH] = ACTIONS(298),
    [anon_sym_BSLASHk_LT] = ACTIONS(296),
    [sym_group_begin] = ACTIONS(296),
    [sym_group_end] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_CARET] = ACTIONS(296),
    [anon_sym_BSLASHb] = ACTIONS(296),
    [sym_character_class_escape] = ACTIONS(296),
    [anon_sym_BSLASH0] = ACTIONS(296),
    [sym_special_escape] = ACTIONS(296),
    [sym_end_assertion] = ACTIONS(296),
    [sym_non_boundary_assertion] = ACTIONS(296),
    [sym_any_character] = ACTIONS(296),
    [sym_non_syntax_character] = ACTIONS(296),
    [sym_null_character] = ACTIONS(296),
  },
  [65] = {
    [ts_builtin_sym_end] = ACTIONS(300),
    [sym_disjunction_delimiter] = ACTIONS(300),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(300),
    [anon_sym_BSLASH] = ACTIONS(302),
    [anon_sym_BSLASHk_LT] = ACTIONS(300),
    [sym_group_begin] = ACTIONS(300),
    [sym_group_end] = ACTIONS(300),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_CARET] = ACTIONS(300),
    [anon_sym_BSLASHb] = ACTIONS(300),
    [sym_character_class_escape] = ACTIONS(300),
    [anon_sym_BSLASH0] = ACTIONS(300),
    [sym_special_escape] = ACTIONS(300),
    [sym_end_assertion] = ACTIONS(300),
    [sym_non_boundary_assertion] = ACTIONS(300),
    [sym_any_character] = ACTIONS(300),
    [sym_non_syntax_character] = ACTIONS(300),
    [sym_null_character] = ACTIONS(300),
  },
  [66] = {
    [ts_builtin_sym_end] = ACTIONS(304),
    [sym_disjunction_delimiter] = ACTIONS(304),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(304),
    [anon_sym_LBRACE] = ACTIONS(304),
    [anon_sym_BSLASH] = ACTIONS(306),
    [anon_sym_BSLASHk_LT] = ACTIONS(304),
    [sym_group_begin] = ACTIONS(304),
    [sym_group_end] = ACTIONS(304),
    [anon_sym_LBRACK] = ACTIONS(304),
    [anon_sym_CARET] = ACTIONS(304),
    [anon_sym_BSLASHb] = ACTIONS(304),
    [sym_character_class_escape] = ACTIONS(304),
    [anon_sym_BSLASH0] = ACTIONS(304),
    [sym_special_escape] = ACTIONS(304),
    [sym_end_assertion] = ACTIONS(304),
    [sym_non_boundary_assertion] = ACTIONS(304),
    [sym_any_character] = ACTIONS(304),
    [sym_non_syntax_character] = ACTIONS(304),
    [sym_null_character] = ACTIONS(304),
  },
  [67] = {
    [ts_builtin_sym_end] = ACTIONS(308),
    [sym_disjunction_delimiter] = ACTIONS(308),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(308),
    [anon_sym_LBRACE] = ACTIONS(308),
    [anon_sym_BSLASH] = ACTIONS(310),
    [anon_sym_BSLASHk_LT] = ACTIONS(308),
    [sym_group_begin] = ACTIONS(308),
    [sym_group_end] = ACTIONS(308),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_CARET] = ACTIONS(308),
    [anon_sym_BSLASHb] = ACTIONS(308),
    [sym_character_class_escape] = ACTIONS(308),
    [anon_sym_BSLASH0] = ACTIONS(308),
    [sym_special_escape] = ACTIONS(308),
    [sym_end_assertion] = ACTIONS(308),
    [sym_non_boundary_assertion] = ACTIONS(308),
    [sym_any_character] = ACTIONS(308),
    [sym_non_syntax_character] = ACTIONS(308),
    [sym_null_character] = ACTIONS(308),
  },
  [68] = {
    [sym_set_range] = STATE(74),
    [sym_set_octal_escape] = STATE(87),
    [sym_set_identity_escape] = STATE(87),
    [sym_identity_escape] = STATE(87),
    [sym_octal_escape] = STATE(90),
    [sym_unicode_escape] = STATE(90),
    [sym_hexadecimal_escape] = STATE(90),
    [sym_control_letter_escape] = STATE(90),
    [sym__escape_operator] = STATE(118),
    [aux_sym_character_set_repeat1] = STATE(74),
    [anon_sym_BSLASH] = ACTIONS(312),
    [anon_sym_CARET] = ACTIONS(314),
    [anon_sym_RBRACK] = ACTIONS(316),
    [aux_sym_set_atom_token1] = ACTIONS(318),
    [anon_sym_BSLASHb] = ACTIONS(320),
    [sym_character_class_escape] = ACTIONS(322),
    [anon_sym_BSLASH0] = ACTIONS(324),
    [sym_special_escape] = ACTIONS(326),
    [sym_null_character] = ACTIONS(326),
  },
  [69] = {
    [ts_builtin_sym_end] = ACTIONS(328),
    [sym_disjunction_delimiter] = ACTIONS(328),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(328),
    [anon_sym_LBRACE] = ACTIONS(328),
    [anon_sym_BSLASH] = ACTIONS(330),
    [anon_sym_BSLASHk_LT] = ACTIONS(328),
    [sym_group_begin] = ACTIONS(328),
    [sym_group_end] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(328),
    [anon_sym_CARET] = ACTIONS(328),
    [anon_sym_BSLASHb] = ACTIONS(328),
    [sym_character_class_escape] = ACTIONS(328),
    [anon_sym_BSLASH0] = ACTIONS(328),
    [sym_special_escape] = ACTIONS(328),
    [sym_end_assertion] = ACTIONS(328),
    [sym_non_boundary_assertion] = ACTIONS(328),
    [sym_any_character] = ACTIONS(328),
    [sym_non_syntax_character] = ACTIONS(328),
    [sym_null_character] = ACTIONS(328),
  },
  [70] = {
    [ts_builtin_sym_end] = ACTIONS(332),
    [sym_disjunction_delimiter] = ACTIONS(332),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(332),
    [anon_sym_LBRACE] = ACTIONS(332),
    [anon_sym_BSLASH] = ACTIONS(334),
    [anon_sym_BSLASHk_LT] = ACTIONS(332),
    [sym_group_begin] = ACTIONS(332),
    [sym_group_end] = ACTIONS(332),
    [anon_sym_LBRACK] = ACTIONS(332),
    [anon_sym_CARET] = ACTIONS(332),
    [anon_sym_BSLASHb] = ACTIONS(332),
    [sym_character_class_escape] = ACTIONS(332),
    [anon_sym_BSLASH0] = ACTIONS(332),
    [sym_special_escape] = ACTIONS(332),
    [sym_end_assertion] = ACTIONS(332),
    [sym_non_boundary_assertion] = ACTIONS(332),
    [sym_any_character] = ACTIONS(332),
    [sym_non_syntax_character] = ACTIONS(332),
    [sym_null_character] = ACTIONS(332),
  },
  [71] = {
    [ts_builtin_sym_end] = ACTIONS(39),
    [sym_disjunction_delimiter] = ACTIONS(39),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(336),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_BSLASH] = ACTIONS(338),
    [anon_sym_BSLASHk_LT] = ACTIONS(39),
    [sym_group_begin] = ACTIONS(39),
    [sym_group_end] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_CARET] = ACTIONS(39),
    [anon_sym_BSLASHb] = ACTIONS(39),
    [sym_character_class_escape] = ACTIONS(39),
    [anon_sym_BSLASH0] = ACTIONS(39),
    [sym_special_escape] = ACTIONS(39),
    [sym_end_assertion] = ACTIONS(39),
    [sym_non_boundary_assertion] = ACTIONS(39),
    [sym_any_character] = ACTIONS(39),
    [sym_non_syntax_character] = ACTIONS(39),
    [sym_null_character] = ACTIONS(39),
  },
  [72] = {
    [ts_builtin_sym_end] = ACTIONS(340),
    [sym_disjunction_delimiter] = ACTIONS(340),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(342),
    [anon_sym_LBRACE] = ACTIONS(342),
    [anon_sym_BSLASH] = ACTIONS(344),
    [anon_sym_BSLASHk_LT] = ACTIONS(340),
    [sym_group_begin] = ACTIONS(340),
    [sym_group_end] = ACTIONS(340),
    [anon_sym_LBRACK] = ACTIONS(340),
    [anon_sym_CARET] = ACTIONS(340),
    [anon_sym_BSLASHb] = ACTIONS(340),
    [sym_character_class_escape] = ACTIONS(340),
    [anon_sym_BSLASH0] = ACTIONS(340),
    [sym_special_escape] = ACTIONS(340),
    [sym_end_assertion] = ACTIONS(340),
    [sym_non_boundary_assertion] = ACTIONS(340),
    [sym_any_character] = ACTIONS(340),
    [sym_non_syntax_character] = ACTIONS(340),
    [sym_null_character] = ACTIONS(340),
  },
  [73] = {
    [ts_builtin_sym_end] = ACTIONS(346),
    [sym_disjunction_delimiter] = ACTIONS(346),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(348),
    [anon_sym_LBRACE] = ACTIONS(348),
    [anon_sym_BSLASH] = ACTIONS(350),
    [anon_sym_BSLASHk_LT] = ACTIONS(346),
    [sym_group_begin] = ACTIONS(346),
    [sym_group_end] = ACTIONS(346),
    [anon_sym_LBRACK] = ACTIONS(346),
    [anon_sym_CARET] = ACTIONS(346),
    [anon_sym_BSLASHb] = ACTIONS(346),
    [sym_character_class_escape] = ACTIONS(346),
    [anon_sym_BSLASH0] = ACTIONS(346),
    [sym_special_escape] = ACTIONS(346),
    [sym_end_assertion] = ACTIONS(346),
    [sym_non_boundary_assertion] = ACTIONS(346),
    [sym_any_character] = ACTIONS(346),
    [sym_non_syntax_character] = ACTIONS(346),
    [sym_null_character] = ACTIONS(346),
  },
  [74] = {
    [sym_set_range] = STATE(77),
    [sym_set_octal_escape] = STATE(87),
    [sym_set_identity_escape] = STATE(87),
    [sym_identity_escape] = STATE(87),
    [sym_octal_escape] = STATE(90),
    [sym_unicode_escape] = STATE(90),
    [sym_hexadecimal_escape] = STATE(90),
    [sym_control_letter_escape] = STATE(90),
    [sym__escape_operator] = STATE(118),
    [aux_sym_character_set_repeat1] = STATE(77),
    [anon_sym_BSLASH] = ACTIONS(312),
    [anon_sym_RBRACK] = ACTIONS(352),
    [aux_sym_set_atom_token1] = ACTIONS(354),
    [anon_sym_BSLASHb] = ACTIONS(320),
    [sym_character_class_escape] = ACTIONS(322),
    [anon_sym_BSLASH0] = ACTIONS(324),
    [sym_special_escape] = ACTIONS(326),
    [sym_null_character] = ACTIONS(326),
  },
  [75] = {
    [sym_set_range] = STATE(76),
    [sym_set_octal_escape] = STATE(87),
    [sym_set_identity_escape] = STATE(87),
    [sym_identity_escape] = STATE(87),
    [sym_octal_escape] = STATE(90),
    [sym_unicode_escape] = STATE(90),
    [sym_hexadecimal_escape] = STATE(90),
    [sym_control_letter_escape] = STATE(90),
    [sym__escape_operator] = STATE(118),
    [aux_sym_character_set_repeat1] = STATE(76),
    [anon_sym_BSLASH] = ACTIONS(312),
    [anon_sym_RBRACK] = ACTIONS(356),
    [aux_sym_set_atom_token1] = ACTIONS(354),
    [anon_sym_BSLASHb] = ACTIONS(320),
    [sym_character_class_escape] = ACTIONS(322),
    [anon_sym_BSLASH0] = ACTIONS(324),
    [sym_special_escape] = ACTIONS(326),
    [sym_null_character] = ACTIONS(326),
  },
  [76] = {
    [sym_set_range] = STATE(77),
    [sym_set_octal_escape] = STATE(87),
    [sym_set_identity_escape] = STATE(87),
    [sym_identity_escape] = STATE(87),
    [sym_octal_escape] = STATE(90),
    [sym_unicode_escape] = STATE(90),
    [sym_hexadecimal_escape] = STATE(90),
    [sym_control_letter_escape] = STATE(90),
    [sym__escape_operator] = STATE(118),
    [aux_sym_character_set_repeat1] = STATE(77),
    [anon_sym_BSLASH] = ACTIONS(312),
    [anon_sym_RBRACK] = ACTIONS(358),
    [aux_sym_set_atom_token1] = ACTIONS(354),
    [anon_sym_BSLASHb] = ACTIONS(320),
    [sym_character_class_escape] = ACTIONS(322),
    [anon_sym_BSLASH0] = ACTIONS(324),
    [sym_special_escape] = ACTIONS(326),
    [sym_null_character] = ACTIONS(326),
  },
  [77] = {
    [sym_set_range] = STATE(77),
    [sym_set_octal_escape] = STATE(87),
    [sym_set_identity_escape] = STATE(87),
    [sym_identity_escape] = STATE(87),
    [sym_octal_escape] = STATE(90),
    [sym_unicode_escape] = STATE(90),
    [sym_hexadecimal_escape] = STATE(90),
    [sym_control_letter_escape] = STATE(90),
    [sym__escape_operator] = STATE(118),
    [aux_sym_character_set_repeat1] = STATE(77),
    [anon_sym_BSLASH] = ACTIONS(360),
    [anon_sym_RBRACK] = ACTIONS(363),
    [aux_sym_set_atom_token1] = ACTIONS(365),
    [anon_sym_BSLASHb] = ACTIONS(368),
    [sym_character_class_escape] = ACTIONS(371),
    [anon_sym_BSLASH0] = ACTIONS(374),
    [sym_special_escape] = ACTIONS(377),
    [sym_null_character] = ACTIONS(377),
  },
  [78] = {
    [ts_builtin_sym_end] = ACTIONS(39),
    [sym_disjunction_delimiter] = ACTIONS(39),
    [anon_sym_BSLASH] = ACTIONS(338),
    [anon_sym_BSLASHk_LT] = ACTIONS(39),
    [sym_group_begin] = ACTIONS(39),
    [sym_group_end] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_CARET] = ACTIONS(39),
    [anon_sym_BSLASHb] = ACTIONS(39),
    [sym_character_class_escape] = ACTIONS(39),
    [anon_sym_BSLASH0] = ACTIONS(39),
    [sym_special_escape] = ACTIONS(39),
    [sym_end_assertion] = ACTIONS(39),
    [sym_non_boundary_assertion] = ACTIONS(39),
    [sym_any_character] = ACTIONS(39),
    [sym_non_syntax_character] = ACTIONS(39),
    [sym_null_character] = ACTIONS(39),
  },
  [79] = {
    [ts_builtin_sym_end] = ACTIONS(380),
    [sym_disjunction_delimiter] = ACTIONS(380),
    [anon_sym_BSLASH] = ACTIONS(382),
    [anon_sym_BSLASHk_LT] = ACTIONS(380),
    [sym_group_begin] = ACTIONS(380),
    [sym_group_end] = ACTIONS(380),
    [anon_sym_LBRACK] = ACTIONS(380),
    [anon_sym_CARET] = ACTIONS(380),
    [anon_sym_BSLASHb] = ACTIONS(380),
    [sym_character_class_escape] = ACTIONS(380),
    [anon_sym_BSLASH0] = ACTIONS(380),
    [sym_special_escape] = ACTIONS(380),
    [sym_end_assertion] = ACTIONS(380),
    [sym_non_boundary_assertion] = ACTIONS(380),
    [sym_any_character] = ACTIONS(380),
    [sym_non_syntax_character] = ACTIONS(380),
    [sym_null_character] = ACTIONS(380),
  },
  [80] = {
    [ts_builtin_sym_end] = ACTIONS(384),
    [sym_disjunction_delimiter] = ACTIONS(384),
    [anon_sym_BSLASH] = ACTIONS(386),
    [anon_sym_BSLASHk_LT] = ACTIONS(384),
    [sym_group_begin] = ACTIONS(384),
    [sym_group_end] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(384),
    [anon_sym_CARET] = ACTIONS(384),
    [anon_sym_BSLASHb] = ACTIONS(384),
    [sym_character_class_escape] = ACTIONS(384),
    [anon_sym_BSLASH0] = ACTIONS(384),
    [sym_special_escape] = ACTIONS(384),
    [sym_end_assertion] = ACTIONS(384),
    [sym_non_boundary_assertion] = ACTIONS(384),
    [sym_any_character] = ACTIONS(384),
    [sym_non_syntax_character] = ACTIONS(384),
    [sym_null_character] = ACTIONS(384),
  },
  [81] = {
    [ts_builtin_sym_end] = ACTIONS(388),
    [sym_disjunction_delimiter] = ACTIONS(388),
    [anon_sym_BSLASH] = ACTIONS(390),
    [anon_sym_BSLASHk_LT] = ACTIONS(388),
    [sym_group_begin] = ACTIONS(388),
    [sym_group_end] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(388),
    [anon_sym_CARET] = ACTIONS(388),
    [anon_sym_BSLASHb] = ACTIONS(388),
    [sym_character_class_escape] = ACTIONS(388),
    [anon_sym_BSLASH0] = ACTIONS(388),
    [sym_special_escape] = ACTIONS(388),
    [sym_end_assertion] = ACTIONS(388),
    [sym_non_boundary_assertion] = ACTIONS(388),
    [sym_any_character] = ACTIONS(388),
    [sym_non_syntax_character] = ACTIONS(388),
    [sym_null_character] = ACTIONS(388),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(340),
    [sym_disjunction_delimiter] = ACTIONS(340),
    [anon_sym_BSLASH] = ACTIONS(344),
    [anon_sym_BSLASHk_LT] = ACTIONS(340),
    [sym_group_begin] = ACTIONS(340),
    [sym_group_end] = ACTIONS(340),
    [anon_sym_LBRACK] = ACTIONS(340),
    [anon_sym_CARET] = ACTIONS(340),
    [anon_sym_BSLASHb] = ACTIONS(340),
    [sym_character_class_escape] = ACTIONS(340),
    [anon_sym_BSLASH0] = ACTIONS(340),
    [sym_special_escape] = ACTIONS(340),
    [sym_end_assertion] = ACTIONS(340),
    [sym_non_boundary_assertion] = ACTIONS(340),
    [sym_any_character] = ACTIONS(340),
    [sym_non_syntax_character] = ACTIONS(340),
    [sym_null_character] = ACTIONS(340),
  },
  [83] = {
    [ts_builtin_sym_end] = ACTIONS(346),
    [sym_disjunction_delimiter] = ACTIONS(346),
    [anon_sym_BSLASH] = ACTIONS(350),
    [anon_sym_BSLASHk_LT] = ACTIONS(346),
    [sym_group_begin] = ACTIONS(346),
    [sym_group_end] = ACTIONS(346),
    [anon_sym_LBRACK] = ACTIONS(346),
    [anon_sym_CARET] = ACTIONS(346),
    [anon_sym_BSLASHb] = ACTIONS(346),
    [sym_character_class_escape] = ACTIONS(346),
    [anon_sym_BSLASH0] = ACTIONS(346),
    [sym_special_escape] = ACTIONS(346),
    [sym_end_assertion] = ACTIONS(346),
    [sym_non_boundary_assertion] = ACTIONS(346),
    [sym_any_character] = ACTIONS(346),
    [sym_non_syntax_character] = ACTIONS(346),
    [sym_null_character] = ACTIONS(346),
  },
  [84] = {
    [sym_set_octal_escape] = STATE(110),
    [sym_set_identity_escape] = STATE(110),
    [sym_identity_escape] = STATE(110),
    [sym_octal_escape] = STATE(109),
    [sym_unicode_escape] = STATE(109),
    [sym_hexadecimal_escape] = STATE(109),
    [sym_control_letter_escape] = STATE(109),
    [sym__escape_operator] = STATE(127),
    [anon_sym_BSLASH] = ACTIONS(392),
    [anon_sym_RBRACK] = ACTIONS(394),
    [aux_sym_set_atom_token1] = ACTIONS(396),
    [anon_sym_BSLASHb] = ACTIONS(398),
    [sym_character_class_escape] = ACTIONS(394),
    [anon_sym_BSLASH0] = ACTIONS(400),
    [sym_special_escape] = ACTIONS(402),
    [sym_null_character] = ACTIONS(402),
  },
  [85] = {
    [sym_set_octal_escape] = STATE(114),
    [sym_set_identity_escape] = STATE(114),
    [sym_identity_escape] = STATE(114),
    [sym_octal_escape] = STATE(113),
    [sym_unicode_escape] = STATE(113),
    [sym_hexadecimal_escape] = STATE(113),
    [sym_control_letter_escape] = STATE(113),
    [sym__escape_operator] = STATE(127),
    [anon_sym_BSLASH] = ACTIONS(392),
    [anon_sym_RBRACK] = ACTIONS(404),
    [aux_sym_set_atom_token1] = ACTIONS(406),
    [anon_sym_BSLASHb] = ACTIONS(408),
    [sym_character_class_escape] = ACTIONS(404),
    [anon_sym_BSLASH0] = ACTIONS(400),
    [sym_special_escape] = ACTIONS(410),
    [sym_null_character] = ACTIONS(410),
  },
  [86] = {
    [anon_sym_BSLASH] = ACTIONS(412),
    [anon_sym_BSLASHk_LT] = ACTIONS(414),
    [sym_group_begin] = ACTIONS(414),
    [sym_group_end] = ACTIONS(414),
    [anon_sym_LBRACK] = ACTIONS(414),
    [anon_sym_CARET] = ACTIONS(414),
    [anon_sym_BSLASHb] = ACTIONS(414),
    [sym_character_class_escape] = ACTIONS(414),
    [anon_sym_BSLASH0] = ACTIONS(414),
    [sym_special_escape] = ACTIONS(414),
    [sym_end_assertion] = ACTIONS(414),
    [sym_non_boundary_assertion] = ACTIONS(414),
    [sym_any_character] = ACTIONS(414),
    [sym_non_syntax_character] = ACTIONS(414),
    [sym_null_character] = ACTIONS(414),
  },
  [87] = {
    [anon_sym_BSLASH] = ACTIONS(416),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_RBRACK] = ACTIONS(420),
    [aux_sym_set_atom_token1] = ACTIONS(416),
    [anon_sym_BSLASHb] = ACTIONS(420),
    [sym_character_class_escape] = ACTIONS(420),
    [anon_sym_BSLASH0] = ACTIONS(420),
    [sym_special_escape] = ACTIONS(420),
    [sym_null_character] = ACTIONS(420),
  },
  [88] = {
    [anon_sym_BSLASH] = ACTIONS(210),
    [anon_sym_DASH] = ACTIONS(208),
    [anon_sym_RBRACK] = ACTIONS(208),
    [aux_sym_set_atom_token1] = ACTIONS(210),
    [anon_sym_BSLASHb] = ACTIONS(208),
    [sym_character_class_escape] = ACTIONS(208),
    [anon_sym_BSLASH0] = ACTIONS(208),
    [sym_special_escape] = ACTIONS(208),
    [sym_null_character] = ACTIONS(208),
  },
  [89] = {
    [anon_sym_BSLASH] = ACTIONS(214),
    [anon_sym_DASH] = ACTIONS(212),
    [anon_sym_RBRACK] = ACTIONS(212),
    [aux_sym_set_atom_token1] = ACTIONS(214),
    [anon_sym_BSLASHb] = ACTIONS(212),
    [sym_character_class_escape] = ACTIONS(212),
    [anon_sym_BSLASH0] = ACTIONS(212),
    [sym_special_escape] = ACTIONS(212),
    [sym_null_character] = ACTIONS(212),
  },
  [90] = {
    [anon_sym_BSLASH] = ACTIONS(416),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_RBRACK] = ACTIONS(420),
    [aux_sym_set_atom_token1] = ACTIONS(416),
    [anon_sym_BSLASHb] = ACTIONS(420),
    [sym_character_class_escape] = ACTIONS(420),
    [anon_sym_BSLASH0] = ACTIONS(420),
    [sym_special_escape] = ACTIONS(420),
    [sym_null_character] = ACTIONS(420),
  },
  [91] = {
    [anon_sym_BSLASH] = ACTIONS(422),
    [anon_sym_DASH] = ACTIONS(424),
    [anon_sym_RBRACK] = ACTIONS(424),
    [aux_sym_set_atom_token1] = ACTIONS(422),
    [anon_sym_BSLASHb] = ACTIONS(424),
    [sym_character_class_escape] = ACTIONS(424),
    [anon_sym_BSLASH0] = ACTIONS(424),
    [sym_special_escape] = ACTIONS(424),
    [sym_null_character] = ACTIONS(424),
  },
  [92] = {
    [anon_sym_BSLASH] = ACTIONS(426),
    [anon_sym_DASH] = ACTIONS(428),
    [anon_sym_RBRACK] = ACTIONS(430),
    [aux_sym_set_atom_token1] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(430),
    [sym_character_class_escape] = ACTIONS(430),
    [anon_sym_BSLASH0] = ACTIONS(430),
    [sym_special_escape] = ACTIONS(430),
    [sym_null_character] = ACTIONS(430),
  },
  [93] = {
    [anon_sym_BSLASH] = ACTIONS(432),
    [anon_sym_DASH] = ACTIONS(434),
    [anon_sym_RBRACK] = ACTIONS(436),
    [aux_sym_set_atom_token1] = ACTIONS(432),
    [anon_sym_BSLASHb] = ACTIONS(436),
    [sym_character_class_escape] = ACTIONS(436),
    [anon_sym_BSLASH0] = ACTIONS(436),
    [sym_special_escape] = ACTIONS(436),
    [sym_null_character] = ACTIONS(436),
  },
  [94] = {
    [anon_sym_BSLASH] = ACTIONS(258),
    [anon_sym_DASH] = ACTIONS(256),
    [anon_sym_RBRACK] = ACTIONS(256),
    [aux_sym_set_atom_token1] = ACTIONS(258),
    [anon_sym_BSLASHb] = ACTIONS(256),
    [sym_character_class_escape] = ACTIONS(256),
    [anon_sym_BSLASH0] = ACTIONS(256),
    [sym_special_escape] = ACTIONS(256),
    [sym_null_character] = ACTIONS(256),
  },
  [95] = {
    [anon_sym_BSLASH] = ACTIONS(416),
    [anon_sym_DASH] = ACTIONS(438),
    [anon_sym_RBRACK] = ACTIONS(420),
    [aux_sym_set_atom_token1] = ACTIONS(416),
    [anon_sym_BSLASHb] = ACTIONS(420),
    [sym_character_class_escape] = ACTIONS(420),
    [anon_sym_BSLASH0] = ACTIONS(420),
    [sym_special_escape] = ACTIONS(420),
    [sym_null_character] = ACTIONS(420),
  },
  [96] = {
    [anon_sym_BSLASH] = ACTIONS(440),
    [anon_sym_DASH] = ACTIONS(442),
    [anon_sym_RBRACK] = ACTIONS(442),
    [aux_sym_set_atom_token1] = ACTIONS(440),
    [anon_sym_BSLASHb] = ACTIONS(442),
    [sym_character_class_escape] = ACTIONS(442),
    [anon_sym_BSLASH0] = ACTIONS(442),
    [sym_special_escape] = ACTIONS(442),
    [sym_null_character] = ACTIONS(442),
  },
  [97] = {
    [anon_sym_BSLASH] = ACTIONS(254),
    [anon_sym_DASH] = ACTIONS(252),
    [anon_sym_RBRACK] = ACTIONS(252),
    [aux_sym_set_atom_token1] = ACTIONS(254),
    [anon_sym_BSLASHb] = ACTIONS(252),
    [sym_character_class_escape] = ACTIONS(252),
    [anon_sym_BSLASH0] = ACTIONS(252),
    [sym_special_escape] = ACTIONS(252),
    [sym_null_character] = ACTIONS(252),
  },
  [98] = {
    [anon_sym_BSLASH] = ACTIONS(444),
    [anon_sym_DASH] = ACTIONS(446),
    [anon_sym_RBRACK] = ACTIONS(448),
    [aux_sym_set_atom_token1] = ACTIONS(444),
    [anon_sym_BSLASHb] = ACTIONS(448),
    [sym_character_class_escape] = ACTIONS(448),
    [anon_sym_BSLASH0] = ACTIONS(448),
    [sym_special_escape] = ACTIONS(448),
    [sym_null_character] = ACTIONS(448),
  },
  [99] = {
    [anon_sym_BSLASH] = ACTIONS(250),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_RBRACK] = ACTIONS(248),
    [aux_sym_set_atom_token1] = ACTIONS(250),
    [anon_sym_BSLASHb] = ACTIONS(248),
    [sym_character_class_escape] = ACTIONS(248),
    [anon_sym_BSLASH0] = ACTIONS(248),
    [sym_special_escape] = ACTIONS(248),
    [sym_null_character] = ACTIONS(248),
  },
  [100] = {
    [anon_sym_BSLASH] = ACTIONS(440),
    [anon_sym_RBRACK] = ACTIONS(442),
    [aux_sym_set_atom_token1] = ACTIONS(442),
    [anon_sym_BSLASHb] = ACTIONS(442),
    [sym_character_class_escape] = ACTIONS(442),
    [anon_sym_BSLASH0] = ACTIONS(442),
    [sym_special_escape] = ACTIONS(442),
    [sym_null_character] = ACTIONS(442),
  },
  [101] = {
    [anon_sym_BSLASH] = ACTIONS(450),
    [anon_sym_RBRACK] = ACTIONS(452),
    [aux_sym_set_atom_token1] = ACTIONS(452),
    [anon_sym_BSLASHb] = ACTIONS(452),
    [sym_character_class_escape] = ACTIONS(452),
    [anon_sym_BSLASH0] = ACTIONS(452),
    [sym_special_escape] = ACTIONS(452),
    [sym_null_character] = ACTIONS(452),
  },
  [102] = {
    [anon_sym_BSLASH] = ACTIONS(258),
    [anon_sym_RBRACK] = ACTIONS(256),
    [aux_sym_set_atom_token1] = ACTIONS(256),
    [anon_sym_BSLASHb] = ACTIONS(256),
    [sym_character_class_escape] = ACTIONS(256),
    [anon_sym_BSLASH0] = ACTIONS(256),
    [sym_special_escape] = ACTIONS(256),
    [sym_null_character] = ACTIONS(256),
  },
  [103] = {
    [anon_sym_BSLASH] = ACTIONS(250),
    [anon_sym_RBRACK] = ACTIONS(248),
    [aux_sym_set_atom_token1] = ACTIONS(248),
    [anon_sym_BSLASHb] = ACTIONS(248),
    [sym_character_class_escape] = ACTIONS(248),
    [anon_sym_BSLASH0] = ACTIONS(248),
    [sym_special_escape] = ACTIONS(248),
    [sym_null_character] = ACTIONS(248),
  },
  [104] = {
    [anon_sym_BSLASH] = ACTIONS(422),
    [anon_sym_RBRACK] = ACTIONS(424),
    [aux_sym_set_atom_token1] = ACTIONS(424),
    [anon_sym_BSLASHb] = ACTIONS(424),
    [sym_character_class_escape] = ACTIONS(424),
    [anon_sym_BSLASH0] = ACTIONS(424),
    [sym_special_escape] = ACTIONS(424),
    [sym_null_character] = ACTIONS(424),
  },
  [105] = {
    [anon_sym_BSLASH] = ACTIONS(210),
    [anon_sym_RBRACK] = ACTIONS(208),
    [aux_sym_set_atom_token1] = ACTIONS(208),
    [anon_sym_BSLASHb] = ACTIONS(208),
    [sym_character_class_escape] = ACTIONS(208),
    [anon_sym_BSLASH0] = ACTIONS(208),
    [sym_special_escape] = ACTIONS(208),
    [sym_null_character] = ACTIONS(208),
  },
  [106] = {
    [anon_sym_BSLASH] = ACTIONS(214),
    [anon_sym_RBRACK] = ACTIONS(212),
    [aux_sym_set_atom_token1] = ACTIONS(212),
    [anon_sym_BSLASHb] = ACTIONS(212),
    [sym_character_class_escape] = ACTIONS(212),
    [anon_sym_BSLASH0] = ACTIONS(212),
    [sym_special_escape] = ACTIONS(212),
    [sym_null_character] = ACTIONS(212),
  },
  [107] = {
    [anon_sym_BSLASH] = ACTIONS(254),
    [anon_sym_RBRACK] = ACTIONS(252),
    [aux_sym_set_atom_token1] = ACTIONS(252),
    [anon_sym_BSLASHb] = ACTIONS(252),
    [sym_character_class_escape] = ACTIONS(252),
    [anon_sym_BSLASH0] = ACTIONS(252),
    [sym_special_escape] = ACTIONS(252),
    [sym_null_character] = ACTIONS(252),
  },
  [108] = {
    [anon_sym_BSLASH] = ACTIONS(454),
    [anon_sym_RBRACK] = ACTIONS(456),
    [aux_sym_set_atom_token1] = ACTIONS(456),
    [anon_sym_BSLASHb] = ACTIONS(456),
    [sym_character_class_escape] = ACTIONS(456),
    [anon_sym_BSLASH0] = ACTIONS(456),
    [sym_special_escape] = ACTIONS(456),
    [sym_null_character] = ACTIONS(456),
  },
  [109] = {
    [anon_sym_BSLASH] = ACTIONS(458),
    [anon_sym_RBRACK] = ACTIONS(460),
    [aux_sym_set_atom_token1] = ACTIONS(460),
    [anon_sym_BSLASHb] = ACTIONS(460),
    [sym_character_class_escape] = ACTIONS(460),
    [anon_sym_BSLASH0] = ACTIONS(460),
    [sym_special_escape] = ACTIONS(460),
    [sym_null_character] = ACTIONS(460),
  },
  [110] = {
    [anon_sym_BSLASH] = ACTIONS(458),
    [anon_sym_RBRACK] = ACTIONS(460),
    [aux_sym_set_atom_token1] = ACTIONS(460),
    [anon_sym_BSLASHb] = ACTIONS(460),
    [sym_character_class_escape] = ACTIONS(460),
    [anon_sym_BSLASH0] = ACTIONS(460),
    [sym_special_escape] = ACTIONS(460),
    [sym_null_character] = ACTIONS(460),
  },
  [111] = {
    [anon_sym_BSLASH] = ACTIONS(462),
    [anon_sym_RBRACK] = ACTIONS(464),
    [aux_sym_set_atom_token1] = ACTIONS(464),
    [anon_sym_BSLASHb] = ACTIONS(464),
    [sym_character_class_escape] = ACTIONS(464),
    [anon_sym_BSLASH0] = ACTIONS(464),
    [sym_special_escape] = ACTIONS(464),
    [sym_null_character] = ACTIONS(464),
  },
  [112] = {
    [anon_sym_BSLASH] = ACTIONS(466),
    [anon_sym_RBRACK] = ACTIONS(468),
    [aux_sym_set_atom_token1] = ACTIONS(468),
    [anon_sym_BSLASHb] = ACTIONS(468),
    [sym_character_class_escape] = ACTIONS(468),
    [anon_sym_BSLASH0] = ACTIONS(468),
    [sym_special_escape] = ACTIONS(468),
    [sym_null_character] = ACTIONS(468),
  },
  [113] = {
    [anon_sym_BSLASH] = ACTIONS(470),
    [anon_sym_RBRACK] = ACTIONS(472),
    [aux_sym_set_atom_token1] = ACTIONS(472),
    [anon_sym_BSLASHb] = ACTIONS(472),
    [sym_character_class_escape] = ACTIONS(472),
    [anon_sym_BSLASH0] = ACTIONS(472),
    [sym_special_escape] = ACTIONS(472),
    [sym_null_character] = ACTIONS(472),
  },
  [114] = {
    [anon_sym_BSLASH] = ACTIONS(470),
    [anon_sym_RBRACK] = ACTIONS(472),
    [aux_sym_set_atom_token1] = ACTIONS(472),
    [anon_sym_BSLASHb] = ACTIONS(472),
    [sym_character_class_escape] = ACTIONS(472),
    [anon_sym_BSLASH0] = ACTIONS(472),
    [sym_special_escape] = ACTIONS(472),
    [sym_null_character] = ACTIONS(472),
  },
  [115] = {
    [anon_sym_BSLASH] = ACTIONS(474),
    [anon_sym_RBRACK] = ACTIONS(394),
    [aux_sym_set_atom_token1] = ACTIONS(394),
    [anon_sym_BSLASHb] = ACTIONS(394),
    [sym_character_class_escape] = ACTIONS(394),
    [anon_sym_BSLASH0] = ACTIONS(394),
    [sym_special_escape] = ACTIONS(394),
    [sym_null_character] = ACTIONS(394),
  },
  [116] = {
    [aux_sym_set_octal_escape_token1] = ACTIONS(476),
    [aux_sym_set_identity_escape_token1] = ACTIONS(478),
    [aux_sym_identity_escape_token1] = ACTIONS(478),
    [anon_sym_u] = ACTIONS(480),
    [anon_sym_x] = ACTIONS(482),
    [anon_sym_c] = ACTIONS(484),
  },
  [117] = {
    [aux_sym_set_octal_escape_token1] = ACTIONS(486),
    [aux_sym_set_identity_escape_token1] = ACTIONS(478),
    [aux_sym_identity_escape_token1] = ACTIONS(478),
    [anon_sym_u] = ACTIONS(488),
    [anon_sym_x] = ACTIONS(491),
    [anon_sym_c] = ACTIONS(494),
  },
  [118] = {
    [aux_sym_set_identity_escape_token1] = ACTIONS(497),
    [aux_sym_identity_escape_token1] = ACTIONS(499),
    [anon_sym_u] = ACTIONS(501),
    [anon_sym_x] = ACTIONS(501),
    [anon_sym_c] = ACTIONS(503),
  },
  [119] = {
    [aux_sym_backreference_token1] = ACTIONS(505),
    [aux_sym_identity_escape_token1] = ACTIONS(478),
    [anon_sym_u] = ACTIONS(507),
    [anon_sym_x] = ACTIONS(510),
    [anon_sym_c] = ACTIONS(513),
  },
  [120] = {
    [sym_unicode_escape] = STATE(122),
    [aux_sym_group_name_repeat1] = STATE(122),
    [anon_sym_BSLASH] = ACTIONS(516),
    [anon_sym_GT] = ACTIONS(518),
    [aux_sym_group_name_token2] = ACTIONS(520),
  },
  [121] = {
    [sym_unicode_escape] = STATE(121),
    [aux_sym_group_name_repeat1] = STATE(121),
    [anon_sym_BSLASH] = ACTIONS(522),
    [anon_sym_GT] = ACTIONS(525),
    [aux_sym_group_name_token2] = ACTIONS(527),
  },
  [122] = {
    [sym_unicode_escape] = STATE(121),
    [aux_sym_group_name_repeat1] = STATE(121),
    [anon_sym_BSLASH] = ACTIONS(516),
    [anon_sym_GT] = ACTIONS(530),
    [aux_sym_group_name_token2] = ACTIONS(532),
  },
  [123] = {
    [aux_sym_identity_escape_token1] = ACTIONS(534),
    [anon_sym_u] = ACTIONS(536),
    [anon_sym_x] = ACTIONS(536),
    [anon_sym_c] = ACTIONS(538),
  },
  [124] = {
    [sym_group_name] = STATE(148),
    [sym_unicode_escape] = STATE(120),
    [anon_sym_BSLASH] = ACTIONS(516),
    [aux_sym_group_name_token1] = ACTIONS(540),
  },
  [125] = {
    [sym_group_name] = STATE(147),
    [sym_unicode_escape] = STATE(120),
    [anon_sym_BSLASH] = ACTIONS(516),
    [aux_sym_group_name_token1] = ACTIONS(540),
  },
  [126] = {
    [anon_sym_BSLASH] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [aux_sym_group_name_token2] = ACTIONS(256),
  },
  [127] = {
    [aux_sym_set_identity_escape_token1] = ACTIONS(542),
    [aux_sym_identity_escape_token1] = ACTIONS(544),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(546),
    [sym_group_end] = ACTIONS(546),
  },
  [129] = {
    [aux_sym_count_quantifier_token1] = ACTIONS(548),
    [anon_sym_RBRACE] = ACTIONS(550),
  },
  [130] = {
    [anon_sym_COMMA] = ACTIONS(552),
    [anon_sym_RBRACE] = ACTIONS(554),
  },
  [131] = {
    [aux_sym_hexadecimal_escape_token1] = ACTIONS(556),
  },
  [132] = {
    [sym_group_end] = ACTIONS(558),
  },
  [133] = {
    [ts_builtin_sym_end] = ACTIONS(560),
  },
  [134] = {
    [aux_sym_octal_escape_token1] = ACTIONS(562),
  },
  [135] = {
    [sym_group_end] = ACTIONS(564),
  },
  [136] = {
    [sym_group_end] = ACTIONS(566),
  },
  [137] = {
    [sym_group_end] = ACTIONS(568),
  },
  [138] = {
    [anon_sym_RBRACE] = ACTIONS(570),
  },
  [139] = {
    [sym_group_end] = ACTIONS(572),
  },
  [140] = {
    [ts_builtin_sym_end] = ACTIONS(574),
  },
  [141] = {
    [sym_group_end] = ACTIONS(576),
  },
  [142] = {
    [aux_sym_unicode_escape_token1] = ACTIONS(578),
  },
  [143] = {
    [sym_group_end] = ACTIONS(580),
  },
  [144] = {
    [aux_sym_count_quantifier_token1] = ACTIONS(582),
  },
  [145] = {
    [aux_sym_control_letter_escape_token1] = ACTIONS(584),
  },
  [146] = {
    [anon_sym_u] = ACTIONS(586),
  },
  [147] = {
    [anon_sym_GT] = ACTIONS(588),
  },
  [148] = {
    [anon_sym_GT] = ACTIONS(590),
  },
  [149] = {
    [aux_sym_octal_escape_token1] = ACTIONS(592),
  },
  [150] = {
    [aux_sym_unicode_escape_token1] = ACTIONS(594),
  },
  [151] = {
    [aux_sym_hexadecimal_escape_token1] = ACTIONS(596),
  },
  [152] = {
    [aux_sym_control_letter_escape_token1] = ACTIONS(598),
  },
  [153] = {
    [aux_sym_octal_escape_token1] = ACTIONS(600),
  },
  [154] = {
    [aux_sym_unicode_escape_token1] = ACTIONS(602),
  },
  [155] = {
    [aux_sym_hexadecimal_escape_token1] = ACTIONS(604),
  },
  [156] = {
    [aux_sym_control_letter_escape_token1] = ACTIONS(606),
  },
  [157] = {
    [aux_sym_unicode_escape_token1] = ACTIONS(608),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, SHIFT(119),
  [5] = {.count = 1, .reusable = true}, SHIFT(125),
  [7] = {.count = 1, .reusable = true}, SHIFT(2),
  [9] = {.count = 1, .reusable = true}, SHIFT(68),
  [11] = {.count = 1, .reusable = true}, SHIFT(34),
  [13] = {.count = 1, .reusable = true}, SHIFT(42),
  [15] = {.count = 1, .reusable = true}, SHIFT(20),
  [17] = {.count = 1, .reusable = true}, SHIFT(134),
  [19] = {.count = 1, .reusable = true}, SHIFT(23),
  [21] = {.count = 1, .reusable = true}, SHIFT(16),
  [23] = {.count = 1, .reusable = true}, SHIFT(17),
  [25] = {.count = 1, .reusable = true}, SHIFT(18),
  [27] = {.count = 1, .reusable = true}, SHIFT(19),
  [29] = {.count = 1, .reusable = false}, SHIFT(124),
  [31] = {.count = 1, .reusable = true}, SHIFT(15),
  [33] = {.count = 1, .reusable = true}, SHIFT(35),
  [35] = {.count = 1, .reusable = true}, REDUCE(sym_disjunction, 2),
  [37] = {.count = 1, .reusable = true}, SHIFT(13),
  [39] = {.count = 1, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2),
  [41] = {.count = 2, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(119),
  [44] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(125),
  [47] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(2),
  [50] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(68),
  [53] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(34),
  [56] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(42),
  [59] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(20),
  [62] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(134),
  [65] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(23),
  [68] = {.count = 1, .reusable = true}, SHIFT(40),
  [70] = {.count = 1, .reusable = true}, SHIFT(41),
  [72] = {.count = 1, .reusable = true}, SHIFT(24),
  [74] = {.count = 1, .reusable = true}, SHIFT(43),
  [76] = {.count = 1, .reusable = true}, SHIFT(50),
  [78] = {.count = 1, .reusable = true}, SHIFT(52),
  [80] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 1),
  [82] = {.count = 1, .reusable = true}, SHIFT(32),
  [84] = {.count = 1, .reusable = true}, REDUCE(sym_disjunction, 1),
  [86] = {.count = 1, .reusable = true}, SHIFT(33),
  [88] = {.count = 1, .reusable = true}, SHIFT(38),
  [90] = {.count = 1, .reusable = true}, SHIFT(53),
  [92] = {.count = 1, .reusable = true}, SHIFT(48),
  [94] = {.count = 1, .reusable = true}, SHIFT(44),
  [96] = {.count = 1, .reusable = true}, SHIFT(25),
  [98] = {.count = 1, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 1),
  [100] = {.count = 1, .reusable = true}, SHIFT(78),
  [102] = {.count = 1, .reusable = false}, SHIFT(144),
  [104] = {.count = 1, .reusable = true}, SHIFT(58),
  [106] = {.count = 1, .reusable = true}, SHIFT(63),
  [108] = {.count = 1, .reusable = true}, SHIFT(61),
  [110] = {.count = 1, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 1),
  [112] = {.count = 1, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2, .production_id = 3),
  [114] = {.count = 1, .reusable = true}, SHIFT(83),
  [116] = {.count = 1, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 2, .production_id = 3),
  [118] = {.count = 1, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2, .production_id = 2),
  [120] = {.count = 1, .reusable = true}, SHIFT(82),
  [122] = {.count = 1, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 2, .production_id = 2),
  [124] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookbehind_assertion, 4),
  [126] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookbehind_assertion, 4),
  [128] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookbehind_assertion, 3),
  [130] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookbehind_assertion, 3),
  [132] = {.count = 1, .reusable = true}, REDUCE(sym_character_set, 3),
  [134] = {.count = 1, .reusable = false}, REDUCE(sym_character_set, 3),
  [136] = {.count = 1, .reusable = true}, REDUCE(sym_backreference, 2),
  [138] = {.count = 1, .reusable = false}, REDUCE(sym_backreference, 2),
  [140] = {.count = 1, .reusable = true}, REDUCE(sym_lookbehind_assertion, 5),
  [142] = {.count = 1, .reusable = false}, REDUCE(sym_lookbehind_assertion, 5),
  [144] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookahead_assertion, 5),
  [146] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookahead_assertion, 5),
  [148] = {.count = 1, .reusable = true}, REDUCE(sym_lookahead_assertion, 5),
  [150] = {.count = 1, .reusable = false}, REDUCE(sym_lookahead_assertion, 5),
  [152] = {.count = 1, .reusable = true}, REDUCE(sym_character_set, 3, .production_id = 6),
  [154] = {.count = 1, .reusable = false}, REDUCE(sym_character_set, 3, .production_id = 6),
  [156] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_capturing_group, 3),
  [158] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_capturing_group, 3),
  [160] = {.count = 1, .reusable = true}, REDUCE(sym_named_capturing_group, 3),
  [162] = {.count = 1, .reusable = false}, REDUCE(sym_named_capturing_group, 3),
  [164] = {.count = 1, .reusable = true}, REDUCE(sym_start_assertion, 1),
  [166] = {.count = 1, .reusable = false}, REDUCE(sym_start_assertion, 1),
  [168] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_capturing_group, 2),
  [170] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_capturing_group, 2),
  [172] = {.count = 1, .reusable = true}, REDUCE(sym_character_set, 4, .production_id = 6),
  [174] = {.count = 1, .reusable = false}, REDUCE(sym_character_set, 4, .production_id = 6),
  [176] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_capturing_group, 4),
  [178] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_capturing_group, 4),
  [180] = {.count = 1, .reusable = true}, REDUCE(sym_non_capturing_group, 3),
  [182] = {.count = 1, .reusable = false}, REDUCE(sym_non_capturing_group, 3),
  [184] = {.count = 1, .reusable = true}, REDUCE(sym_character_set, 2),
  [186] = {.count = 1, .reusable = false}, REDUCE(sym_character_set, 2),
  [188] = {.count = 1, .reusable = true}, REDUCE(sym_named_capturing_group, 4),
  [190] = {.count = 1, .reusable = false}, REDUCE(sym_named_capturing_group, 4),
  [192] = {.count = 1, .reusable = true}, REDUCE(sym_non_capturing_group, 4),
  [194] = {.count = 1, .reusable = false}, REDUCE(sym_non_capturing_group, 4),
  [196] = {.count = 1, .reusable = true}, REDUCE(sym_boundary_assertion, 1),
  [198] = {.count = 1, .reusable = false}, REDUCE(sym_boundary_assertion, 1),
  [200] = {.count = 1, .reusable = true}, REDUCE(sym_lookbehind_assertion, 4),
  [202] = {.count = 1, .reusable = false}, REDUCE(sym_lookbehind_assertion, 4),
  [204] = {.count = 1, .reusable = true}, REDUCE(sym_lookbehind_assertion, 3),
  [206] = {.count = 1, .reusable = false}, REDUCE(sym_lookbehind_assertion, 3),
  [208] = {.count = 1, .reusable = true}, REDUCE(sym_octal_escape, 2),
  [210] = {.count = 1, .reusable = false}, REDUCE(sym_octal_escape, 2),
  [212] = {.count = 1, .reusable = true}, REDUCE(sym_identity_escape, 2, .production_id = 2),
  [214] = {.count = 1, .reusable = false}, REDUCE(sym_identity_escape, 2, .production_id = 2),
  [216] = {.count = 1, .reusable = true}, REDUCE(sym_named_capturing_group, 5),
  [218] = {.count = 1, .reusable = false}, REDUCE(sym_named_capturing_group, 5),
  [220] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookahead_assertion, 3),
  [222] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookahead_assertion, 3),
  [224] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookbehind_assertion, 5),
  [226] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookbehind_assertion, 5),
  [228] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookahead_assertion, 4),
  [230] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookahead_assertion, 4),
  [232] = {.count = 1, .reusable = true}, REDUCE(sym_non_capturing_group, 5),
  [234] = {.count = 1, .reusable = false}, REDUCE(sym_non_capturing_group, 5),
  [236] = {.count = 1, .reusable = true}, REDUCE(sym_lookahead_assertion, 4),
  [238] = {.count = 1, .reusable = false}, REDUCE(sym_lookahead_assertion, 4),
  [240] = {.count = 1, .reusable = true}, REDUCE(sym_lookahead_assertion, 3),
  [242] = {.count = 1, .reusable = false}, REDUCE(sym_lookahead_assertion, 3),
  [244] = {.count = 1, .reusable = true}, REDUCE(sym_backreference, 3),
  [246] = {.count = 1, .reusable = false}, REDUCE(sym_backreference, 3),
  [248] = {.count = 1, .reusable = true}, REDUCE(sym_control_letter_escape, 3),
  [250] = {.count = 1, .reusable = false}, REDUCE(sym_control_letter_escape, 3),
  [252] = {.count = 1, .reusable = true}, REDUCE(sym_hexadecimal_escape, 3),
  [254] = {.count = 1, .reusable = false}, REDUCE(sym_hexadecimal_escape, 3),
  [256] = {.count = 1, .reusable = true}, REDUCE(sym_unicode_escape, 3),
  [258] = {.count = 1, .reusable = false}, REDUCE(sym_unicode_escape, 3),
  [260] = {.count = 1, .reusable = true}, REDUCE(sym_zero_or_more, 1),
  [262] = {.count = 1, .reusable = false}, REDUCE(sym_zero_or_more, 1),
  [264] = {.count = 1, .reusable = true}, SHIFT(66),
  [266] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 4),
  [268] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 4),
  [270] = {.count = 1, .reusable = true}, SHIFT(70),
  [272] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 3),
  [274] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 3),
  [276] = {.count = 1, .reusable = true}, SHIFT(64),
  [278] = {.count = 1, .reusable = true}, REDUCE(sym_one_or_more, 1),
  [280] = {.count = 1, .reusable = false}, REDUCE(sym_one_or_more, 1),
  [282] = {.count = 1, .reusable = true}, SHIFT(65),
  [284] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 5),
  [286] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 5),
  [288] = {.count = 1, .reusable = true}, SHIFT(67),
  [290] = {.count = 1, .reusable = true}, REDUCE(sym_optional, 1),
  [292] = {.count = 1, .reusable = false}, REDUCE(sym_optional, 1),
  [294] = {.count = 1, .reusable = true}, SHIFT(69),
  [296] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 4, .production_id = 14),
  [298] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 4, .production_id = 14),
  [300] = {.count = 1, .reusable = true}, REDUCE(sym_one_or_more, 2, .production_id = 4),
  [302] = {.count = 1, .reusable = false}, REDUCE(sym_one_or_more, 2, .production_id = 4),
  [304] = {.count = 1, .reusable = true}, REDUCE(sym_zero_or_more, 2, .production_id = 4),
  [306] = {.count = 1, .reusable = false}, REDUCE(sym_zero_or_more, 2, .production_id = 4),
  [308] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 6, .production_id = 16),
  [310] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 6, .production_id = 16),
  [312] = {.count = 1, .reusable = false}, SHIFT(117),
  [314] = {.count = 1, .reusable = true}, SHIFT(75),
  [316] = {.count = 1, .reusable = true}, SHIFT(39),
  [318] = {.count = 1, .reusable = false}, SHIFT(87),
  [320] = {.count = 1, .reusable = true}, SHIFT(93),
  [322] = {.count = 1, .reusable = true}, SHIFT(95),
  [324] = {.count = 1, .reusable = true}, SHIFT(149),
  [326] = {.count = 1, .reusable = true}, SHIFT(90),
  [328] = {.count = 1, .reusable = true}, REDUCE(sym_optional, 2, .production_id = 4),
  [330] = {.count = 1, .reusable = false}, REDUCE(sym_optional, 2, .production_id = 4),
  [332] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 5, .production_id = 15),
  [334] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 5, .production_id = 15),
  [336] = {.count = 1, .reusable = true}, SHIFT(81),
  [338] = {.count = 1, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 2),
  [340] = {.count = 1, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 3, .production_id = 2),
  [342] = {.count = 1, .reusable = true}, SHIFT(79),
  [344] = {.count = 1, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 3, .production_id = 2),
  [346] = {.count = 1, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 3, .production_id = 3),
  [348] = {.count = 1, .reusable = true}, SHIFT(80),
  [350] = {.count = 1, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 3, .production_id = 3),
  [352] = {.count = 1, .reusable = true}, SHIFT(26),
  [354] = {.count = 1, .reusable = true}, SHIFT(87),
  [356] = {.count = 1, .reusable = true}, SHIFT(31),
  [358] = {.count = 1, .reusable = true}, SHIFT(36),
  [360] = {.count = 2, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(117),
  [363] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2),
  [365] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(87),
  [368] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(93),
  [371] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(95),
  [374] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(149),
  [377] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(90),
  [380] = {.count = 1, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 4, .production_id = 2),
  [382] = {.count = 1, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 4, .production_id = 2),
  [384] = {.count = 1, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 4, .production_id = 3),
  [386] = {.count = 1, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 4, .production_id = 3),
  [388] = {.count = 1, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 3),
  [390] = {.count = 1, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 3),
  [392] = {.count = 1, .reusable = false}, SHIFT(116),
  [394] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2, .production_id = 5),
  [396] = {.count = 1, .reusable = true}, SHIFT(110),
  [398] = {.count = 1, .reusable = true}, SHIFT(111),
  [400] = {.count = 1, .reusable = true}, SHIFT(153),
  [402] = {.count = 1, .reusable = true}, SHIFT(109),
  [404] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2, .production_id = 7),
  [406] = {.count = 1, .reusable = true}, SHIFT(114),
  [408] = {.count = 1, .reusable = true}, SHIFT(101),
  [410] = {.count = 1, .reusable = true}, SHIFT(113),
  [412] = {.count = 1, .reusable = false}, REDUCE(sym_named_capturing_group_identifier, 3),
  [414] = {.count = 1, .reusable = true}, REDUCE(sym_named_capturing_group_identifier, 3),
  [416] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 1),
  [418] = {.count = 1, .reusable = true}, SHIFT(84),
  [420] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 1),
  [422] = {.count = 1, .reusable = false}, REDUCE(sym_set_identity_escape, 2, .production_id = 2),
  [424] = {.count = 1, .reusable = true}, REDUCE(sym_set_identity_escape, 2, .production_id = 2),
  [426] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 2, .production_id = 2),
  [428] = {.count = 1, .reusable = true}, SHIFT(108),
  [430] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2, .production_id = 2),
  [432] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 1, .production_id = 1),
  [434] = {.count = 1, .reusable = true}, SHIFT(85),
  [436] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 1, .production_id = 1),
  [438] = {.count = 1, .reusable = true}, SHIFT(115),
  [440] = {.count = 1, .reusable = false}, REDUCE(sym_set_octal_escape, 2),
  [442] = {.count = 1, .reusable = true}, REDUCE(sym_set_octal_escape, 2),
  [444] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 2, .production_id = 3),
  [446] = {.count = 1, .reusable = true}, SHIFT(112),
  [448] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2, .production_id = 3),
  [450] = {.count = 1, .reusable = false}, REDUCE(sym_set_range, 3, .production_id = 11),
  [452] = {.count = 1, .reusable = true}, REDUCE(sym_set_range, 3, .production_id = 11),
  [454] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 3, .production_id = 12),
  [456] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 3, .production_id = 12),
  [458] = {.count = 1, .reusable = false}, REDUCE(sym_set_range, 3, .production_id = 8),
  [460] = {.count = 1, .reusable = true}, REDUCE(sym_set_range, 3, .production_id = 8),
  [462] = {.count = 1, .reusable = false}, REDUCE(sym_set_range, 3, .production_id = 9),
  [464] = {.count = 1, .reusable = true}, REDUCE(sym_set_range, 3, .production_id = 9),
  [466] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 3, .production_id = 13),
  [468] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 3, .production_id = 13),
  [470] = {.count = 1, .reusable = false}, REDUCE(sym_set_range, 3, .production_id = 10),
  [472] = {.count = 1, .reusable = true}, REDUCE(sym_set_range, 3, .production_id = 10),
  [474] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 2, .production_id = 5),
  [476] = {.count = 1, .reusable = true}, SHIFT(100),
  [478] = {.count = 1, .reusable = true}, REDUCE(sym__escape_operator, 1),
  [480] = {.count = 1, .reusable = true}, SHIFT(157),
  [482] = {.count = 1, .reusable = true}, SHIFT(155),
  [484] = {.count = 1, .reusable = true}, SHIFT(156),
  [486] = {.count = 1, .reusable = true}, SHIFT(96),
  [488] = {.count = 2, .reusable = true}, REDUCE(sym__escape_operator, 1), SHIFT(154),
  [491] = {.count = 2, .reusable = true}, REDUCE(sym__escape_operator, 1), SHIFT(151),
  [494] = {.count = 2, .reusable = true}, REDUCE(sym__escape_operator, 1), SHIFT(152),
  [497] = {.count = 1, .reusable = true}, SHIFT(91),
  [499] = {.count = 1, .reusable = true}, SHIFT(89),
  [501] = {.count = 1, .reusable = true}, SHIFT(92),
  [503] = {.count = 1, .reusable = true}, SHIFT(98),
  [505] = {.count = 1, .reusable = true}, SHIFT(27),
  [507] = {.count = 2, .reusable = true}, REDUCE(sym__escape_operator, 1), SHIFT(142),
  [510] = {.count = 2, .reusable = true}, REDUCE(sym__escape_operator, 1), SHIFT(131),
  [513] = {.count = 2, .reusable = true}, REDUCE(sym__escape_operator, 1), SHIFT(145),
  [516] = {.count = 1, .reusable = true}, SHIFT(146),
  [518] = {.count = 1, .reusable = true}, REDUCE(sym_group_name, 1),
  [520] = {.count = 1, .reusable = true}, SHIFT(122),
  [522] = {.count = 2, .reusable = true}, REDUCE(aux_sym_group_name_repeat1, 2), SHIFT_REPEAT(146),
  [525] = {.count = 1, .reusable = true}, REDUCE(aux_sym_group_name_repeat1, 2),
  [527] = {.count = 2, .reusable = true}, REDUCE(aux_sym_group_name_repeat1, 2), SHIFT_REPEAT(121),
  [530] = {.count = 1, .reusable = true}, REDUCE(sym_group_name, 2),
  [532] = {.count = 1, .reusable = true}, SHIFT(121),
  [534] = {.count = 1, .reusable = true}, SHIFT(46),
  [536] = {.count = 1, .reusable = true}, SHIFT(22),
  [538] = {.count = 1, .reusable = true}, SHIFT(21),
  [540] = {.count = 1, .reusable = true}, SHIFT(120),
  [542] = {.count = 1, .reusable = true}, SHIFT(104),
  [544] = {.count = 1, .reusable = true}, SHIFT(106),
  [546] = {.count = 1, .reusable = true}, REDUCE(sym_disjunction, 3),
  [548] = {.count = 1, .reusable = true}, SHIFT(138),
  [550] = {.count = 1, .reusable = true}, SHIFT(59),
  [552] = {.count = 1, .reusable = true}, SHIFT(129),
  [554] = {.count = 1, .reusable = true}, SHIFT(60),
  [556] = {.count = 1, .reusable = true}, SHIFT(56),
  [558] = {.count = 1, .reusable = true}, SHIFT(37),
  [560] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [562] = {.count = 1, .reusable = true}, SHIFT(45),
  [564] = {.count = 1, .reusable = true}, SHIFT(47),
  [566] = {.count = 1, .reusable = true}, SHIFT(51),
  [568] = {.count = 1, .reusable = true}, SHIFT(49),
  [570] = {.count = 1, .reusable = true}, SHIFT(62),
  [572] = {.count = 1, .reusable = true}, SHIFT(28),
  [574] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 2),
  [576] = {.count = 1, .reusable = true}, SHIFT(29),
  [578] = {.count = 1, .reusable = true}, SHIFT(57),
  [580] = {.count = 1, .reusable = true}, SHIFT(30),
  [582] = {.count = 1, .reusable = true}, SHIFT(130),
  [584] = {.count = 1, .reusable = true}, SHIFT(55),
  [586] = {.count = 1, .reusable = true}, SHIFT(150),
  [588] = {.count = 1, .reusable = true}, SHIFT(54),
  [590] = {.count = 1, .reusable = true}, SHIFT(86),
  [592] = {.count = 1, .reusable = true}, SHIFT(88),
  [594] = {.count = 1, .reusable = true}, SHIFT(126),
  [596] = {.count = 1, .reusable = true}, SHIFT(97),
  [598] = {.count = 1, .reusable = true}, SHIFT(99),
  [600] = {.count = 1, .reusable = true}, SHIFT(105),
  [602] = {.count = 1, .reusable = true}, SHIFT(94),
  [604] = {.count = 1, .reusable = true}, SHIFT(107),
  [606] = {.count = 1, .reusable = true}, SHIFT(103),
  [608] = {.count = 1, .reusable = true}, SHIFT(102),
};

void *tree_sitter_regex_external_scanner_create(void);
void tree_sitter_regex_external_scanner_destroy(void *);
bool tree_sitter_regex_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_regex_external_scanner_serialize(void *, char *);
void tree_sitter_regex_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_regex(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_regex_external_scanner_create,
      tree_sitter_regex_external_scanner_destroy,
      tree_sitter_regex_external_scanner_scan,
      tree_sitter_regex_external_scanner_serialize,
      tree_sitter_regex_external_scanner_deserialize,
    },
  };
  return &language;
}
